#ifndef XBILL_CONFIG_H
#define XBILL_CONFIG_H 1

@TOP@

/* acconfig.h  Generated manually for use by autoheader.  */
/*
 * $Id: acconfig.h,v 1.2 1999/10/10 08:48:17 short Exp $
 */

/* Define if your locale.h file contains LC_MESSAGES.  */
#undef HAVE_LC_MESSAGES

/* Define to 1 if NLS is requested.  */
#undef ENABLE_NLS

/* Define as 1 if you have catgets and don't want to use GNU gettext.  */
#undef HAVE_CATGETS

/* Define as 1 if you have gettext and don't want to use GNU gettext.  */
#undef HAVE_GETTEXT

/* Define as 1 if you have the stpcpy function.  */
#undef HAVE_STPCPY

/* Turn on debugging to stderr. */
#undef DEBUG

/* Disable runtime assertion checks. */
#undef NDEBUG

/* Provide stub for MAX-function if needed. */
#undef HAVE_MAX
#ifndef HAVE_MAX
#define MAX(a,b) ((a)>(b)?(a):(b))
#endif

/* Provide stub for MIN-function if needed. */
#undef HAVE_MIN
#ifndef HAVE_MIN
#define MIN(a,b) ((a)<(b)?(a):(b))
#endif

/* how to declare __atribute__ ((__unused__)) */
#undef ATTR_UNUSED

/* whether they have __atttribute__ ((format(printf,...))) */
#undef HAVE_PRINTFORMAT
#ifdef HAVE_PRINTFORMAT
#define ATTR_PRINTFORMAT(a,b) __attribute__ ((format(printf,(a),(b))))
#else
#define ATTR_PRINTFORMAT(a,b)
#endif

/* Define if using alloca.c.  */
#undef C_ALLOCA
/* AIX requires this to be the first thing in the file.  */
#ifndef __GNUC__
# if HAVE_ALLOCA_H
#  include <alloca.h>
# else
#  ifdef _AIX
 #pragma alloca
#  else
#   ifndef alloca /* predefined by HP cc +Olibcalls */
char *alloca ();
#   endif
#  endif
# endif
#endif

/* Are we using GTK+? */
#undef HAVE_GTK

/* Have they PARAMS macro? */
#undef HAVE_PARAMS
#ifndef HAVE_PARAMS
# if __STDC__ || defined __cplusplus
#  define PARAMS(args) args
# else
#  define PARAMS(args) ()
# endif
#endif

/* Are we using Gnome? */
#undef HAVE_GNOME

/* Which Linux libc are we using? */
#undef LIBC_VERSION

/* Will we compress the images? */
#undef HAVE_LIBZ

/* Where the scorefile will be placed? */
#undef XBILL_SCOREFILE

/* Can we use quick and dirty binary linking? */
#undef HAVE_BINARY_LINK

/* Is libggn.a/so/la available? */
#undef HAVE_LIBGGN

/* Is <ggn.h> available? */
#undef HAVE_GGN_H

/* Disable GTK+ compatibility functions? */
#undef GTK_DISABLE_COMPAT_H

@BOTTOM@
/* GTK+ compatibility defines */
#undef gtk_accel_label_get_accel_width
#undef gtk_container_set_border_width
#undef gtk_notebook_get_current_page
#undef gtk_packer_set_child_packing
#undef gtk_paned_set_gutter_size
#undef gtk_paned_set_handle_size
#undef gtk_scale_get_value_width
#undef gtk_window_set_position
#undef gtk_toggle_button_set_active
#undef gtk_check_menu_item_set_active
#undef gtk_label_set_text

/* gtk_scrolled_window_add_with_viewport() workaround */
#ifdef HAVE_GTK_SCROLLED_WINDOW_ADD_WITH_VIEWPORT
#define GTK_SCROLLED_ADD(a,b) gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW((a)),(b))
#else
#define GTK_SCROLLED_ADD(a,b) gtk_container_add(GTK_CONTAINER((a)),(b))
#endif

/* gtk_widget_add_accelerator is not needed if not available */
#ifndef HAVE_GTK_WIDGET_ADD_ACCELERATOR
#define gtk_widget_add_accelerator(a,b,c,d,e,f)
#endif

/* gtk_label_parse_uline is not needed if not available */
#ifndef HAVE_GTK_LABEL_PARSE_ULINE
#define gtk_label_parse_uline(a,b)
#endif

/* Declaration for gethostname(3)? */
#undef NEED_DECLARATION_GETHOSTNAME
#ifdef NEED_DECLARATION_GETHOSTNAME
#include <unistd.h>
int gethostname(char *name, size_t len);
#endif

/* Declaration for kill(2)? */
#undef NEED_DECLARATION_KILL
#ifdef NEED_DECLARATION_KILL
#include <sys/types.h>
#include <signal.h>
int kill(pid_t pid, int sig);
#endif

/* Declaration for setlinebuf(3)? */
#undef NEED_DECLARATION_SETLINEBUF
#ifdef NEED_DECLARATION_SETLINEBUF
#include <stdio.h>
int setlinebuf(FILE *stream);
#endif

/* Declaration for snprintf(3)? */
#undef NEED_DECLARATION_SNPRINTF
#ifdef NEED_DECLARATION_SNPRINTF
#include <stdio.h>
int snprintf(char *str, size_t n, const char *format, ...);
#endif

/* Declaration for vsnprintf(3)? */
#undef NEED_DECLARATION_VSNPRINTF
#ifdef NEED_DECLARATION_VSNPRINTF
#include <stdio.h>
#include <stdarg.h>
int vsnprintf(char *str, size_t n, const char *format, va_list ap);
#endif

/* Declaration for strdup(3)? */
#undef NEED_DECLARATION_STRDUP
#ifdef NEED_DECLARATION_STRDUP
#include <string.h>
char *strdup(const char *s);
#endif

/* Declaration for atoi(3)? */
#undef NEED_DECLARATION_ATOI
#ifdef NEED_DECLARATION_ATOI
#include <stdlib.h>
int atoi(const char *nptr);
#endif

/* Declaration for free(3)? */
#undef NEED_DECLARATION_FREE
#ifdef NEED_DECLARATION_FREE
#include <stdlib.h>
void free(void *ptr);
#endif

/* Declaration for fdopen(3)? */
#undef NEED_DECLARATION_FDOPEN
#ifdef NEED_DECLARATION_FDOPEN
#include <stdio.h>
FILE *fdopen(int fildes, const char *mode);
#endif

/* snprintf(3) unsafe emulation */
#ifdef HAVE_SNPRINTF
#define VARPRINTF(v,f,d) snprintf((v),sizeof((v)),f,(d))
#define VARPRINTF3(v,f,d1,d2,d3) snprintf((v),sizeof((v)),f,(d1),(d2),(d3))
#else
#define VARPRINTF(v,f,d) sprintf((v),f,(d))
#define VARPRINTF3(v,f,d1,d2,d3) sprintf((v),f,(d1),(d2),(d3))
#endif

/* vsnprintf(3) unsafe emulation */
#ifdef HAVE_VSNPRINTF
#define VARVPRINTF(v,f,d) vsnprintf((v),sizeof((v)),f,(d))
#else
#define VARVPRINTF(v,f,d) vsprintf((v),f,(d))
#endif

/* AIX requires this to be the first thing in the file.  */
/*#ifndef __GNUC__*/
# if HAVE_ALLOCA_H
#  include <alloca.h>
# else
#  ifdef _AIX
 #pragma alloca
#  else
#   ifndef alloca /* predefined by HP cc +Olibcalls */
char *alloca ();
#   endif
#  endif
# endif
/*#endif*/

/*
 * Handles all of the internationalization configuration options.
 * Author: Tom Tromey <tromey@creche.cygnus.com>
 * Stolen from <libgnome/gnome-i18n.h>
 * Modified by Jan Kratochvil <short@ucw.cz>
 */
#ifdef HAVE_GNOME
#include <gnome.h>
#else
#ifdef ENABLE_NLS
#ifdef HAVE_LIBINTL_H
#    include <libintl.h>
#endif /* !HAVE_GNOME && HAVE_LIBINTL_H */
#    define _(String) gettext (String)
#    ifdef gettext_noop
#        define N_(String) gettext_noop (String)
#    else
#        define N_(String) (String)
#    endif
#else /* !HAVE_GNOME && ENABLE_NLS */
/* Stubs that do something close enough.  */
#    define textdomain(String) (String)
#    define gettext(String) (String)
#    define dgettext(Domain,Message) (Message)
#    define dcgettext(Domain,Message,Type) (Message)
#    define bindtextdomain(Domain,Directory) (Domain)
#    define _(String) (String)
#    define N_(String) (String)
#endif /* !HAVE_GNOME && ENABLE_NLS */
#endif /* HAVE_GNOME */

#endif /* XBILL_CONFIG_H */
