<!doctype linuxdoc system>

<!--
	XBill documentation.
 -->

<article>

<title>XBill game
<author>
<label id="authors">
Psychosoft: Main programmer:
	<htmlurl url="mailto:bwelling@tis.com" name="Brian Wellington &lt;bwelling@tis.com&gt;">,
Psychosoft: Programming &amp; graphics:
	<htmlurl url="mailto:matias@hyperimage.com" name="Matias Duarte &lt;matias@hyperimage.com&gt;">,
Enhancements starting from v2.0g:
	<htmlurl url="mailto:short@ucw.cz" name="Jan Kratochvil &lt;short@ucw.cz&gt;">

<date>$Id: xbill.sgml.m4,v 1.1 2000/06/21 03:11:30 short Exp $
<abstract>
XBill enables you to present yourself saving your computers from Wingdows
&lsqb;TM&rsqb; virus.  In this document you will find how to use it, setup
network games and potentially enhance it easily.
</abstract>

<!-- Table of contents -->
<toc>

<!-- Begin the document -->

<sect>User/player's notes
<p>

Your game's objective is to keep all the present computers clean from Wingdows
&lsqb;TM&rsqb;.  This virus is spreading and you have to stop all its eval
servants by left mouse button (clicking to the empty place is useless but it
doesn't cut up you in any way).  The game will pause automatically
m4_ifelse(xbilldef_net,,,`(in single player mode only)')
when you'll move the mouse out of XBill window.  General game hardness depends
on the value of <em>level</em>, of course, it will affect the number of
computers being guarded, number of evil servants for Wingdows &lsqb;TM&rsqb;
distribution and even the existence of wires between the computers.  When
computers are connected by wire (into the network), infection of any computer
from this connected cluster will cause the infection off all the peers in a
while.  Any such infection being currently distributed through the wire can be
cleaned by using the water from the bucket in the upper left corner of the
playing area.

For a more red-blooded view of the game please read its original <ref
id="manpage" name="manual page">, please.

<sect>Manual page
<label id="manpage">
<p><descrip>
m4_include(man.sgml-include)
</descrip>

<sect>Development progress


<sect1>Release notes for 2.1

<sect2>Overview
<p>

From version 2.0g (see <ref id="NEWS" name="NEWS section">) the major overhaul
of xBill code was done.  Last changes by Psychosoft were done in version 2.0.
During 2.0g and 2.1 the most noticable changes list:

<itemize>
<item><ref id="21network" name="Added network support">
<item><ref id="21gtk" name="Added GTK+ widget set support">
<item><ref id="21tools" name="Use of modern configuration tools">
<item><ref id="21ansic" name="C++ kickoff, converted to plain ANSI C">
<item><ref id="21img" name="Image compression in the main binary">
<item><ref id="21cross" name="Targetting cross for multiplayer games">
</itemize>


<sect2>Added network support
<label id="21network">
<p>

Note: Implemented by subpackage found in <tt/ggn/ directory, network still
considered <em>*alpha*</em>.

Quick enable: <tt>./configure --with-ggn</tt>

Support for network play has been added, although this library was never tested
too much.  Moreover real run were done only on <em/Linux/ systems and so even
when coding was done with compatibility in mind, there will be sure serious
problems when using this library on other systems.  These glitches will have to
been sorted out during the future development, if you make any changes, send
them to maintainer (noted as <ref id="authors" name="authors">.

Due to this expected incompatibilities and alpha quality of the code, it is
currently disabled by default.  If you are brave soul and you want to try it,
please specify <tt/--with-ggn/ during configuration (&ldquo;<tt>./configure
--with-ggn</tt>&rdquo;).  Any success or failure stories are welcomed, although
depending on the amount of time required, I make no promises about quick fixes
of it.  This doesn't apply to working patches which are ALWAYS welcomed and
credited in the accompanying documentation/notes.  The chance for the fame is
lying before you!  <tt/:-)/


<sect2>Added GTK+ widget set support
<label id="21gtk">
<p>

Since <em/Xaw/ and <em/Motif/ were dropped, <em/GTK+/ library is required now.
<em/GTK+/ is the famous <em/GIMP ToolKit/, you can download it from: <url
url="http://www.gtk.org/">

xBill should be happy with any reasonable versions starting with <tt/0.99.7/,
although latest <tt/1.2/ releases are best to use, of course.  If you make any
source-level changes and want them to be incorporated into the mainstream,
please try to keep this compatibility, some framework to achieve it can be
found in <tt/configure.in/ or <tt>src/gtk10.&lsqb;ch&rsqb;</tt>.


<sect2>Use of modern configuration tools
<label id="21tools">
<p>

Currently this package has integrated usage of the following tools to be as
much cross-platform compatible as possible: <em/gnome/, <em/automake/,
<em/autoconf/, <em/libtool/, <em/getopt/, <em/gettext/ (i18n).  All the tools
should be transparent to the casual user.  If <em/Gnome/ isn't installed,
non-<em/Gnome/ aware version is compiled as a fallback.  Internationalized
catalogs should really be enhaned with more languages, please send some to the
maintainer.  There are very few messages in the whole code so it doesn't take
too long to translate it.


<sect2>C++ kickoff, converted to plain ANSI C
<label id="21ansic">
<p>

To maintain wider systems compatibility, <em/C++/ was dropped in favor of
<em/ANSI C/.  Not much more to say about it -- probably only that you should
keep the current coding style when enhancing the code.


<sect2>Image compression in the main binary
<label id="21img">
<p>

Original xBill 2.0 required a lot of <tt/xpm//<tt/xbm/ images to be installed
separately along it.  With 2.0g and up these images are compiled into the main
program binary.  This policy should be made optional at configure time,
volunteers for such change are welcomed.  I don't know whether some
compatibility problems may arise in the phase of inclusion during the image
include.  To improve the behaviour even more, if <tt/zlib/ library is found on
your system, it is used to reduce the overall size of the binary (by around
<tt/120KB/).  <tt/zlib/ can be downloaded from: <url
url="http://www.cdrom.com/pub/infozip/zlib/">


<sect2>Targetting cross for multiplayer games
<label id="21cross">
<p>

To support multiplayer gaming, targetting cross was developed
(<tt>src/pixmaps/bang.xpm</tt>).  This targetting cross remains visible even
during single player games as I found it useful.  Possibility of disabling
should be probably made in future versions.


<sect1>Status of porting
<p>

Here's the status of the various ports:

<descrip>
<tag/Mac/
<htmlurl url="mailto:jadams@hyperimage.com" name="Josh Adams &lt;jadams@hyperimage.com&gt;">
mostly finished this, based on a beta of 2.0, but never released it for some reason.

<tag/Java/
<htmlurl url="mailto:anthro@cs.umd.edu" name="Greg Seidman &lt;anthro@cs.umd.edu&gt;">
and <htmlurl url="mailto:bwelling@tis.com" name="Brian Wellington &lt;bwelling@tis.com&gt;">
were working on this, but it's been stalled for a while.  We'll finish it at some point.

<tag>XFree86 for OS/2</tag>
<htmlurl url="mailto:doconno@cc.UManitoba.CA" name="Darwin O'Connor &lt;doconno@cc.UManitoba.CA&gt;">
ported it, and you can get it from <url url="http://home.cc.umanitoba.ca/~doconno/xprogs.html">.

<tag/Linux SVGA/
<htmlurl url="mailto:bwelling@tis.com" name="Brian Wellington &lt;bwelling@tis.com&gt;">
got this mostly working on a beta of 2.0, but it had a couple problems
(mouse support wasn't very good, no menus or windows), and is now hopelessly
outdated.  It does have an <tt/XPM/ and <tt/XBM/ reader.  So, if anyone wants to
finish this (write the missing parts and the new parts), let me know.

</descrip>

<sect1>NEWS file
<label id="NEWS">
<p><descrip>
m4_include(NEWS.sgml-include)
</descrip>

m4_ifelse(xbilldef_net,ggn,`m4_include(ggn-user.sgml-include)')
m4_ifelse(xbilldef_net,ggn,`m4_include(ggn-tech.sgml-include)')

</article>
