#ifndef _GGN_H
#define _GGN_H

/*
 * $Id: ggn.h,v 1.2 2000/09/08 06:10:51 short Exp $
 */

#include <stdlib.h>

#ifdef __BEGIN_DECLS
__BEGIN_DECLS
#else
#ifdef  __cplusplus
extern "C" {
#endif
#endif

#define NSIZE(x) (sizeof((x))/sizeof(*(x)))

/* common.c */
/************/

extern void chk PARAMS((const void *));

/* ggn.c */
/*********/
typedef enum { GGNN_MASTER, GGNN_NEWPLAYER, GGNN_DISPLAYER, GGNN_MEMBER, GGNN_STARTGAME, GGNN_MESSAGE, GGNN_OKPLAYER, GGNN_ERRPLAYER, GGNN_OKMEMBER } ggnn_c;
typedef	enum { GGNC_OKAY, GGNC_QUIT, GGNC_FAIL, GGNC_ITERATE } ggnc_r;
struct ggnconnect {
	ggnc_r r;
	int fd,cur,tot;
	char **names;
	};
extern struct ggnconnect ggnconnpriv;
typedef struct ggnconnect * (ggnboxfunc) PARAMS((char *title,char **statep,int *argcp,char ***argvp));
#define GGNBOX_ID(id) do { if (argcp && *argcp==-1) return((void *)(id)); } while (0)

#define GGNPACKCHAR '~'
#define GGNPACKNULL "NULL"
extern char *ggnpackstate PARAMS((void));
extern void ggnunpackstate PARAMS((char *state));

/* ggnabort() and create new connection to master (redirects=0) */
extern void ggnbegin PARAMS((char *master));
/* Close all connections, reset players */
extern void ggnabort PARAMS((void));
/* Declare ourselves as player[1] in game[2] */
extern void ggnmember PARAMS((char *player,char *game));
/* Start connecting the game */
extern void ggnstart PARAMS((char *server,unsigned others));
/* Send broadcast message */
extern void ggnsendmsg PARAMS((char *));
/* Return ggnconnect or NULL */
extern struct ggnconnect *ggnmove PARAMS((void));
/* Return ggnconnect or NULL */
extern struct ggnconnect *ggnbox PARAMS((char *title,char **statep,int *argcp,char ***argvp,char *filter));
/* Return notify description */
extern const char *ggnnotifymsg PARAMS((ggnn_c code));

/* ggnd.c */
/**********/
extern int ggnd_main PARAMS((int argc,char **argv,int pipefd));

#ifdef __END_DECLS
__END_DECLS
#else
#ifdef  __cplusplus
}
#endif
#endif

#endif /* _GGN_H */
