#include "ggnprivate.h"
#ifndef lint
static char rcsid[] ATTR_UNUSED = "$Id: ggnboxgtk.c,v 1.4 2000/09/08 08:53:15 short Exp $";
#endif

#include <string.h>
#include <setjmp.h>
#include <stdarg.h>

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <gdk/gdk.h>

#ifdef HAVE_GNOME
#include <gnome.h>
#endif

#ifndef HAVE_GTK_WINDOW_SET_MODAL
void gtk_window_set_modal(GtkWindow *window,gboolean modal)
{
	assert(modal);
	gtk_signal_connect_object(GTK_OBJECT(window),"show",GTK_SIGNAL_FUNC(gtk_grab_add   ),GTK_OBJECT(window));
	gtk_signal_connect_object(GTK_OBJECT(window),"hide",GTK_SIGNAL_FUNC(gtk_grab_remove),GTK_OBJECT(window));
}
#endif /* !HAVE_GTK_WINDOW_SET_MODAL */

static char *nullgame=N_("<none>");

/* Don't ask what the following option does, please. I have the same problem. :-) */
/* #define GDK_INPUT_QUIT */

typedef enum { KPR_MASTER,KPR_PLAYER,KPR_MEMBER,KPR_MESSAGE } kprt;
typedef enum { MTT_ERROR,MTT_NOTIFY,MTT_MESSAGE,MTT_MAX } mttt;

GdkColor colortab[MTT_MAX];
const char *colornames[MTT_MAX]={"red","black","blue"};

jmp_buf jumpbuffer;
char isinit;
GtkWidget *mainwin;
struct ggnconnect *gc;
gint gdkifd=-1;
GdkInputCondition gdkicond;
struct list regfds,oldfds;
struct regfd {
	struct regfd *next;
	int fd,tag;
	unsigned active:1;
	unsigned close:1;
	GdkInputCondition cond;
	};
GtkWidget *w_games,*w_members;
GtkWidget *w_master,*w_player,*w_member,*w_message;
GtkWidget *w_msgs,*w_msgv,*w_bstart;
struct list rawgames;
struct rawgame {
	struct rawgame *next;
	struct list rawplayers;
	char *name;
	} *dispgame;
struct rawplayer {
	struct rawplayer *next;
	char *name;
	};
char *regplayer,*regmember;

static void gdk_recovery(void)
{
	dbg(printf("gdk_recovery!!!\n"));
	if (isinit) {
		dbg(printf("already inited/failed\n"));
		return;
		}
	longjmp(jumpbuffer,1);
}

static int removegtkitem(GtkWidget *w2,const char *name)
{
GList *gp;
	dbg(printf("removegtkitem(%p,\"%s\")\n",w2,name));
	for (gp=GTK_LIST(w2)->children;gp;gp=gp->next) {
		dbg(printf("removegtkitem: gp=%p\n",gp));
		if (!strcmp(gtk_object_get_user_data(GTK_OBJECT(gp->data)),name)) {
GtkWidget *w=gp->data;
			dbg(printf("removegtkitem: before remove, w=%p\n",w));
			gtk_container_remove(GTK_CONTAINER(w2),w);
#if 0
			dbg(printf("removegtkitem: before destroy, w=%p\n",w));
			gtk_widget_destroy(w);
#endif
			dbg(printf("removegtkitem succeeded with w=%p\n",w));
			return(1);
			}
		}
	dbg(printf("removegtkitem failed\n"));
	return(0);
}

static void dispmember(char *name)
{
GtkWidget *item;

	dbg(printf("dispmember(\"%s\")\n",name));
	item=gtk_list_item_new_with_label(name);
	gtk_object_set_user_data(GTK_OBJECT(item),name);
	GTK_WIDGET_UNSET_FLAGS(item,GTK_CAN_FOCUS);
	gtk_container_add(GTK_CONTAINER(w_members),item);
	gtk_widget_show(item);
}

static void ghostart(void);

static void updmembers(void)
{
struct rawplayer *rp;

#if 0
GList *gl,*cl=NULL;

	for (gl=GTK_LIST(w_members)->children;gl;gl=gl->next)
		cl=g_list_prepend(cl,gl->data);
	gtk_list_remove_items(GTK_LIST(w_members),cl);
	for (gl=cl;gl;gl=gl->next)
		gtk_widget_destroy(gl->data);
	g_list_free(cl);
#endif

	gtk_list_clear_items(GTK_LIST(w_members),0,-1);

	if (!dispgame) return;
	for (rp=dispgame->rawplayers.head;rp;rp=rp->next) dispmember(rp->name);
	ghostart();
}

static void mymove(void)
{
	gc=ggnmove();
	if (gc->r!=GGNC_ITERATE) gtk_main_quit();
}

static void fn_gameclick(GtkList *list,GtkWidget *widget)
{
struct rawgame *rg;
char *s=gtk_object_get_user_data(GTK_OBJECT(widget));

	for (rg=rawgames.head;rg;rg=rg->next)
		if (!strcmp(rg->name,s)) break;
	if (!rg) return; /* Huh? */
	dispgame=rg;
	updmembers();
	gtk_entry_set_text(GTK_ENTRY(w_member),(!strcmp(rg->name,nullgame)?"":rg->name));
	gtk_window_set_focus(GTK_WINDOW(mainwin),w_member);
#if 0
	ggnmember(gtk_entry_get_text(GTK_ENTRY(w_player)),gtk_entry_get_text(GTK_ENTRY(w_member)));
	mymove();
#endif
}

static void mprint(mttt color,const char *fmt,...)
{
va_list ap;
char buf[LINE_MAX],*bufp;
time_t ctm=time(NULL);
struct tm *tmp=localtime(&ctm);
GtkAdjustment *ga=GTK_ADJUSTMENT(GTK_TEXT(w_msgs)->vadj);

	va_start(ap,fmt);
	bufp=buf+VARPRINTF3(buf,"%02d:%02d:%02d-",tmp->tm_hour,tmp->tm_min,tmp->tm_sec);
	bufp+=VARVPRINTFAT(buf,bufp,fmt,ap);
	va_end(ap);
	if (bufp>=buf+sizeof(buf)-2) bufp=buf+sizeof(buf)-2;
	*bufp++='\n'; *bufp='\0';
	gtk_text_freeze(GTK_TEXT(w_msgs));
	gtk_text_insert(GTK_TEXT(w_msgs),NULL,colortab+color,NULL,buf,-1);
	gtk_text_thaw(GTK_TEXT(w_msgs));
	gtk_adjustment_set_value(ga,MAX(0,ga->upper-ga->page_size));
/* FIXME: gtk_editable_set_position() */
}

static gint fn_keypress(GtkWidget *widget,GdkEventKey *key,kprt code)
{
	if (key->keyval!=GDK_Return) return(FALSE);
	switch (code) {
	case KPR_MASTER:
		ggnbegin(gtk_entry_get_text(GTK_ENTRY(w_master)));
		mymove();
		break;
	case KPR_PLAYER:
	case KPR_MEMBER:
		ggnmember(gtk_entry_get_text(GTK_ENTRY(w_player)),gtk_entry_get_text(GTK_ENTRY(w_member)));
		mymove();
		break;
	case KPR_MESSAGE:
		ggnsendmsg(gtk_entry_get_text(GTK_ENTRY(w_message)));
		gtk_entry_set_text(GTK_ENTRY(w_message),"");
		mymove();
		break;
	default: assert(0);
	}
	return(TRUE);
}

static int remplayer(const char *name)
{
struct rawgame *rg;
struct rawplayer *rp;
int i;

	dbg(printf("remplayer(\"%s\")\n",name));
	for (rg=rawgames.head;rg;rg=rg->next)
	for (rp=rg->rawplayers.head;rp;rp=rp->next)
	if (!name||!strcmp(rp->name,name)) {
		if (rg==dispgame) {
			i=removegtkitem(w_members,rp->name); assert(!!i);
			}
		remmid(&rg->rawplayers,rp);
		free(rp->name);
		free(rp);
		dbg(printf("Checking entries in game %s...\n",rg->name));
		if (!LIST_EMPTY(rg->rawplayers)) return(1);
		dbg(printf("No entries left in game %s...\n",rg->name));
		i=removegtkitem(w_games,rg->name); assert(!!i);
		remmid(&rawgames,rg);
		free(rg->name);
		free(rg);
		if (dispgame!=rg) return(1);
		dispgame=rawgames.head;
		updmembers();
		return(1);
		}
	return(0);
}

static inline void clearall(void)
{
	while (remplayer(NULL));
	assert(LIST_EMPTY(rawgames)); assert(!dispgame);
}

static void addplayer(const char *game,const char *player)
{
struct rawgame *rg;
struct rawplayer *rp;
GtkWidget *item;

	dbg(printf("addplayer(\"%s\",\"%s\")\n",game,player));
	assert(!!player);
	remplayer(player);
	if (game&&!*game) game=NULL;
	if (!game) game=nullgame;
	for (rg=rawgames.head;rg;rg=rg->next)
		if (!strcmp(rg->name,game)) break;
	if (!rg) {
		chk(rg=malloc(sizeof(*rg)));
		chk(rg->name=strdup(game));
		INIT_LIST(rg->rawplayers);
		addtail(&rawgames,rg);
		item=gtk_list_item_new_with_label(game);
		gtk_object_set_user_data(GTK_OBJECT(item),rg->name);
		gtk_container_add(GTK_CONTAINER(w_games),item);
		gtk_widget_show(item);
		if (!dispgame) dispgame=rg;
		}
	chk(rp=malloc(sizeof(*rp)));
	chk(rp->name=strdup(player));
	addtail(&rg->rawplayers,rp);
	if (rg==dispgame) dispmember(rp->name);
	ghostart();
}

static inline struct regfd *getfd(int fd)
{
struct regfd *rfd;

	for (rfd=regfds.head;rfd;rfd=rfd->next) {
		assert(rfd->active);
		if (rfd->fd==fd) return(rfd);
		}
	return(NULL);
}

static void gdkinputfn(gpointer data,gint fd,GdkInputCondition cond)
{
struct regfd *rfd=(struct regfd *)data;

	dbg(printf("gdkinputfn(fd=%d,cond=%u)\n",fd,cond));
	assert(fd==rfd->fd);
	assert(gdkifd==-1);
	if (rfd->close) {
		assert(rfd->active);
		if (close(rfd->fd)) errout("&^close(fd %d)\n",rfd->fd);
		remmid(&regfds,rfd);
		addtail(&oldfds,rfd);
		rfd->active=0;
		}
	if (!rfd->active) {
		gdk_input_remove(rfd->tag);
		remmid(&oldfds,rfd);
		free(rfd);
		return;
		}
	gdkifd=fd;
	gdkicond=cond;
	mymove();
	dbg(printf("MyMove() was for gdkinputfn()\n"));
	gdkifd=-1;
}

static void clearfds(void)
{
struct regfd *rfd;

	dbg(printf("clearfds()\n"));
	while ((rfd=remhead(&regfds))||(rfd=remhead(&oldfds))) {
		dbg(printf("clearfds: rfd=%p,rfd->fd=%d,rfd->active=%d,rfd->close=%d\n",
			rfd,rfd->fd,rfd->active,rfd->close));
		gdk_input_remove(rfd->tag);
		if (rfd->close)
			if (close(rfd->fd)) errout("&^close(fd %d)\n",rfd->fd);
		free(rfd);
		}
}

static char fdsetop(int fd,unsigned flg)
{
struct regfd *rfd;
GdkInputCondition cond;
char closeit=0;

	dbg(printf("fdsetop(%d,%u)\n",fd,flg));
	if (flg&(FSO_CLEAR|FSO_SET)) {
		if ((rfd=getfd(fd))) {
			if (rfd->close) return(0);
			cond=rfd->cond;
			}
		else cond=0;
		if ((flg&FSO_CLOSE)==FSO_CLOSE) {
			closeit=1;
			flg=FSO_SET|FSO_READ;
			}
		if (flg&FSO_CLEAR) {
			if (flg&FSO_READ)   cond&=~GDK_INPUT_READ;
			if (flg&FSO_WRITE)  cond&=~GDK_INPUT_WRITE;
			if (flg&FSO_EXCEPT) cond&=~GDK_INPUT_EXCEPTION;
			}
		else if (flg&FSO_SET) {
			if (flg&FSO_READ)   cond|= GDK_INPUT_READ;
			if (flg&FSO_WRITE)  cond|= GDK_INPUT_WRITE;
			if (flg&FSO_EXCEPT) cond|= GDK_INPUT_EXCEPTION;
			}
		dbg(printf("fdsetop(%d,%u),rfd=%p,rfd->fd=%d,cond=%d,rfd->cond=%d,rfd->close=%d,closeit=%d\n",
			fd,flg,rfd,(rfd?rfd->fd:-1),cond,(rfd?rfd->cond:-1),(rfd?rfd->close:-1),closeit));
		if ((!rfd && cond) || (rfd && cond!=rfd->cond) || closeit) {
			if (rfd) {
				rfd->active=0;
				remmid(&regfds,rfd);
				addtail(&oldfds,rfd);
				}
			if (cond) {
				chk(rfd=malloc(sizeof(*rfd)));
				rfd->fd=fd;
				rfd->cond=cond;
				rfd->active=1;
				rfd->close=closeit;
				rfd->tag=gdk_input_add(fd,cond,(GdkInputFunction)gdkinputfn,rfd);
				addtail(&regfds,rfd);
				dbg(printf("fdsetop(%d,%u) - created new rfd structure\n",fd,flg));
				}
			}
		}
	dbg(printf("fdsetop(%d,%u) - final block\n",fd,flg));
	if (gdkifd!=fd) return(0);
	if (((flg&FSO_READ  )&&(gdkicond&GDK_INPUT_READ     ))
		||((flg&FSO_WRITE )&&(gdkicond&GDK_INPUT_WRITE    ))
		||((flg&FSO_EXCEPT)&&(gdkicond&GDK_INPUT_EXCEPTION)))
			return(1);
	return(0);
}

#ifdef GDK_INPUT_QUIT
static char flagfnflg;
static void flagfunc(void)
{
	flagfnflg=1;
	dbg(printf("flagfunc()\n"));
}
#endif /* GDK_INPUT_QUIT */

static void notifyggn(ggnn_c code,char **spa)
{
char *sp[4];
int i;

	for (i=0;i<NSIZE(sp);i++)
		sp[i]=(spa[i] ? spa[i] : _("<undef>"));
	dbg(printf("notifyggn(code=%d,sp[0]=%s)\n",code,sp[0]));
	mprint((code==GGNN_MESSAGE?MTT_MESSAGE:MTT_NOTIFY),ggnnotifymsg(code),sp[0],sp[1],sp[2],sp[3]);

	switch (code) {
	case GGNN_MASTER:
		if (GTK_WIDGET_HAS_FOCUS(w_master)) gtk_window_set_focus(GTK_WINDOW(mainwin),NULL);
		gtk_entry_set_text(GTK_ENTRY(w_master),sp[0]);
		clearall();
		break;
	case GGNN_NEWPLAYER:
		addplayer(NULL,sp[0]);
		break;
	case GGNN_DISPLAYER:
		remplayer(sp[0]);
		break;
	case GGNN_MEMBER:
		remplayer(sp[0]);
		addplayer(sp[1],sp[0]);
		break;
	case GGNN_STARTGAME: break;
	case GGNN_MESSAGE: break;
	case GGNN_OKPLAYER:
		if (GTK_WIDGET_HAS_FOCUS(w_player)) gtk_window_set_focus(GTK_WINDOW(mainwin),NULL);
		gtk_entry_set_text(GTK_ENTRY(w_player),sp[0]);
		if (regplayer) {
			remplayer(regplayer);
			destroy(regplayer);
			destroy(regmember);
			}
		if (*sp[0]) {
			chk(regplayer=strdup(sp[0]));
			addplayer(regmember,regplayer);
			}
		break;
	case GGNN_ERRPLAYER:
		gtk_entry_set_text(GTK_ENTRY(w_player),"");
		gtk_window_set_focus(GTK_WINDOW(mainwin),w_player);
		if (regplayer) {
			remplayer(regplayer);
			destroy(regplayer);
			}
		break;
	case GGNN_OKMEMBER:
		if (GTK_WIDGET_HAS_FOCUS(w_member)) gtk_window_set_focus(GTK_WINDOW(mainwin),NULL);
		gtk_entry_set_text(GTK_ENTRY(w_member),sp[0]);
		if (regplayer) remplayer(regplayer);
		if (regmember) destroy(regmember);
		if (*sp[0]) chk(regmember=strdup(sp[0]));
		if (regplayer) addplayer(regmember,regplayer);
		break;
	}
}

static void presenterr(char *msg)
{
	mprint(MTT_ERROR,_("ERROR: %s"),msg);
}

static char fn_startfake=0;

static void fn_start(void)
{
struct rawgame *rg=NULL;
struct rawplayer *rp;
unsigned cnt=0;

	if (!regmember) {
		if (!fn_startfake) errout(_("&You must be a member of some game to start it"));
		return;
		}
	for (rg=rawgames.head;rg;rg=rg->next)
		if (!strcmp(rg->name,regmember)) break;
	if (!rg) {
		if (!fn_startfake) errout(_("&Your registered game has ceased to be"));
		return;
		}
	for (rp=rg->rawplayers.head;rp;rp=rp->next) cnt++;
	if (cnt<2) {
		if (!fn_startfake) errout(_("&Game must have at least 2 members"));
		return;
		}
	if (fn_startfake) { fn_startfake=0; return; }
	mprint(MTT_NOTIFY,_("Starting \"%s\" with %u members..."),rg->name,cnt);
	ggnstart(NULL,cnt-1);
	mymove();
}

static void ghostart(void)
{
	fn_startfake=1;
	fn_start();
	gtk_widget_set_sensitive(w_bstart,!fn_startfake);
	fn_startfake=0;
}

static void fn_abort(void)
{
	(gc=&ggnconnpriv)->r=GGNC_FAIL;
	gtk_main_quit();
}

static void fn_quit(void)
{
	(gc=&ggnconnpriv)->r=GGNC_QUIT;
	gtk_main_quit();
}

static GtkWidget *newentry(const char *label,GtkWidget *widget,kprt code)
{
GtkWidget *hbox,*r;

	hbox=gtk_hbox_new(FALSE,10);
		{ GtkWidget *lab;
		lab=gtk_label_new(label);
		gtk_box_pack_start(GTK_BOX(hbox),lab,FALSE,FALSE,0);
		gtk_widget_show(lab);
		}

		{ GtkWidget *ent;
			ent=gtk_entry_new();
			gtk_box_pack_start_defaults(GTK_BOX(hbox),ent);
			gtk_signal_connect(GTK_OBJECT(ent),"key_press_event",GTK_SIGNAL_FUNC(fn_keypress),(gpointer)code);
			gtk_widget_show(ent);
			r=ent;
		}
	gtk_box_pack_start(GTK_BOX(widget),hbox,FALSE,FALSE,0);
	gtk_widget_show(hbox);
	return(r);
}

struct ggnconnect *ggnboxgtk(char *title,char **statep,int *argcp,char ***argvp)
{
int i;

	GGNBOX_ID("x11/gtk");
	dbg(printf("ggnboxgtk()...\n"));
	if (isinit<2) {
#ifdef HAVE_GTK_ACCEL_GROUP_NEW
GtkAccelGroup *accel;
#endif

		if (isinit||setjmp(jumpbuffer)) {
			dbg(printf("failing...\n"));
			isinit=1;
			ggnconnpriv.r=GGNC_FAIL;
			return(&ggnconnpriv);
			}

		dbg(printf("gtk_init...\n"));
/* #if !defined(HAVE_GTK11) || defined(HAVE_GNOME) */
		for (i=1;i<*argcp;i++) if (!strcmp((*argvp)[i],"--gtk-is-initialized")) break;
		if (i==*argcp)
/* #endif */
			{
			atexit(gdk_recovery);
#ifdef HAVE_GNOME
			gnome_init("ggn",VERSION,*argcp,*argvp);
#else
			gtk_init(argcp,argvp);
#endif
			}
		dbg(printf("gtk_inited.\n"));

		nullgame=_(nullgame);
		INIT_LIST(regfds);
		INIT_LIST(oldfds);
		INIT_LIST(rawgames);

#ifdef HAVE_GNOME
		mainwin=gnome_app_new("ggn",_("Generic Game Network"));
#else
		mainwin=gtk_window_new(GTK_WINDOW_TOPLEVEL);
		gtk_window_set_title(GTK_WINDOW(mainwin),title);
		gtk_window_set_modal(GTK_WINDOW(mainwin),TRUE);
#endif

		gtk_signal_connect(GTK_OBJECT(mainwin),"destroy"     ,GTK_SIGNAL_FUNC(gtk_main_quit),NULL);
		gtk_signal_connect(GTK_OBJECT(mainwin),"delete_event",GTK_SIGNAL_FUNC(gtk_main_quit),NULL);

#ifdef HAVE_GTK_ACCEL_GROUP_NEW
		accel=gtk_accel_group_new();
		gtk_accel_group_attach(accel,GTK_OBJECT(mainwin));
#endif

		{ GtkWidget *mainh;
		mainh=gtk_hpaned_new();
			{ GtkWidget *mainv;
			mainv=gtk_vbox_new(FALSE,10);
				{ GtkWidget *hpaned;
				hpaned=gtk_hpaned_new();
					{ GtkWidget *gamesv;
					gamesv=gtk_vbox_new(FALSE,2);
						{ GtkWidget *gamesla;
						gamesla=gtk_alignment_new(0,0.5,0,0);
							{ GtkWidget *gamesl;
							gamesl=gtk_label_new(_("Games:"));
							gtk_container_add(GTK_CONTAINER(gamesla),gamesl);
							gtk_widget_show(gamesl);
							}
						gtk_box_pack_start(GTK_BOX(gamesv),gamesla,FALSE,FALSE,0);
						gtk_widget_show(gamesla);
						}
					
						{ GtkWidget *gamesw;
						gamesw=gtk_scrolled_window_new(NULL,NULL);
							{ GtkWidget *games;
							games=gtk_list_new();
							gtk_list_set_selection_mode(GTK_LIST(games),GTK_SELECTION_BROWSE);
							GTK_SCROLLED_ADD(gamesw,games);
							gtk_signal_connect(GTK_OBJECT(games),"select_child",GTK_SIGNAL_FUNC(fn_gameclick),NULL);
							gtk_widget_show(games);
							w_games=games;
							}
						gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(gamesw),GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
						gtk_box_pack_start_defaults(GTK_BOX(gamesv),gamesw);
						gtk_widget_show(gamesw);
						}
					gtk_paned_add1(GTK_PANED(hpaned),gamesv);
					gtk_widget_show(gamesv);
					}

					{ GtkWidget *membersv;
					membersv=gtk_vbox_new(FALSE,2);
						{ GtkWidget *membersla;
						membersla=gtk_alignment_new(0,0.5,0,0);
							{ GtkWidget *membersl;
							membersl=gtk_label_new(_("Members:"));
							gtk_container_add(GTK_CONTAINER(membersla),membersl);
							gtk_widget_show(membersl);
							}
						gtk_box_pack_start(GTK_BOX(membersv),membersla,FALSE,FALSE,0);
						gtk_widget_show(membersla);
						}
					
						{ GtkWidget *membersw;
						membersw=gtk_scrolled_window_new(NULL,NULL);
							{ GtkWidget *members;
							members=gtk_list_new();
							gtk_list_set_selection_mode(GTK_LIST(members),GTK_SELECTION_EXTENDED);
							GTK_SCROLLED_ADD(membersw,members);
							gtk_widget_show(members);
							w_members=members;
							}
						gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(membersw),GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
						gtk_box_pack_start_defaults(GTK_BOX(membersv),membersw);
						gtk_widget_show(membersw);
						}
					gtk_paned_add2(GTK_PANED(hpaned),membersv);
					gtk_widget_show(membersv);
					}
				gtk_box_pack_start_defaults(GTK_BOX(mainv),hpaned);
				gtk_widget_show(hpaned);
				}

				{ GtkWidget *setts;
				setts=gtk_frame_new(_("Settings:"));
					{ GtkWidget *settv;
					settv=gtk_vbox_new(TRUE,2);

					w_master =newentry(_("Master:") ,settv,KPR_MASTER);
					w_player =newentry(_("Player:") ,settv,KPR_PLAYER);
					w_member =newentry(_("Game:")   ,settv,KPR_MEMBER);
					w_message=newentry(_("Message:"),settv,KPR_MESSAGE);

					gtk_container_add(GTK_CONTAINER(setts),settv);
					gtk_container_set_border_width(GTK_CONTAINER(settv),4);
					gtk_widget_show(settv);
					}
				gtk_box_pack_start(GTK_BOX(mainv),setts,FALSE,FALSE,0);
				gtk_widget_show(setts);
				}

				{ GtkWidget *hbox1;
				hbox1=gtk_hbox_new(TRUE,10);
					{ GtkWidget *bstart,*babort,*bquit;
					bstart=gtk_button_new_with_label(_("Start game"));
					gtk_label_parse_uline(GTK_LABEL(GTK_BIN(bstart)->child),_("_Start game"));
					gtk_signal_connect(GTK_OBJECT(bstart),"clicked",GTK_SIGNAL_FUNC(fn_start),NULL);
					gtk_box_pack_start_defaults(GTK_BOX(hbox1),bstart);
					gtk_widget_set_sensitive(bstart,0);
					gtk_widget_add_accelerator(bstart,"clicked",accel,GDK_s,GDK_MOD1_MASK,GTK_ACCEL_VISIBLE);
					gtk_widget_show(bstart);
					w_bstart=bstart;

					babort=gtk_button_new_with_label(_("Abort"));
					gtk_label_parse_uline(GTK_LABEL(GTK_BIN(babort)->child),_("_Abort"));
					gtk_signal_connect(GTK_OBJECT(babort),"clicked",GTK_SIGNAL_FUNC(fn_abort),NULL);
					gtk_box_pack_start_defaults(GTK_BOX(hbox1),babort);
					gtk_widget_add_accelerator(babort,"clicked",accel,GDK_a,GDK_MOD1_MASK,GTK_ACCEL_VISIBLE);
					gtk_widget_show(babort);

					bquit=gtk_button_new_with_label(_("Quit"));
					gtk_label_parse_uline(GTK_LABEL(GTK_BIN(bquit)->child),_("_Quit"));
					gtk_signal_connect(GTK_OBJECT(bquit),"clicked",GTK_SIGNAL_FUNC(fn_quit),NULL);
					gtk_box_pack_start_defaults(GTK_BOX(hbox1),bquit);
					gtk_widget_add_accelerator(babort,"clicked",accel,GDK_q,GDK_MOD1_MASK,GTK_ACCEL_VISIBLE);
					gtk_widget_show(bquit);
					}
				gtk_box_pack_start(GTK_BOX(mainv),hbox1,FALSE,FALSE,0);
				gtk_widget_show(hbox1);
				}

			gtk_paned_add1(GTK_PANED(mainh),mainv);
			gtk_widget_show(mainv);
			}

			{ GtkWidget *msgf;
			msgf=gtk_frame_new(_("Message log:"));
				{ GtkWidget *msgt;
				msgt=gtk_table_new(2,2,FALSE);
					{ GtkWidget *msgs;
					msgs=gtk_text_new(NULL,NULL);
					gtk_widget_set_usize(msgs,320,60);
					GTK_WIDGET_UNSET_FLAGS(msgs,GTK_CAN_FOCUS);
					gtk_table_attach_defaults(GTK_TABLE(msgt),msgs,0,1,0,1);
					gtk_widget_show(msgs);
					w_msgs=msgs;
#if 0
						{ GtkWidget *msgh;
						msgh=gtk_hscrollbar_new(GTK_TEXT(msgs)->hadj);
						gtk_table_attach(GTK_TABLE(msgt),msgh,0,1,1,2,GTK_EXPAND|GTK_FILL,GTK_FILL,0,0);
						gtk_widget_show(msgh);
						}
#endif

						{ GtkWidget *msgv;
						msgv=gtk_vscrollbar_new(GTK_TEXT(msgs)->vadj);
						gtk_table_attach(GTK_TABLE(msgt),msgv,1,2,0,1,GTK_FILL,GTK_EXPAND|GTK_FILL,0,0);
						gtk_widget_show(msgv);
						w_msgv=msgv;
						}
					}
				gtk_container_add(GTK_CONTAINER(msgf),msgt);
				gtk_widget_show(msgt);
				}
			gtk_paned_add2(GTK_PANED(mainh),msgf);
			gtk_widget_show(msgf);
			}
		gtk_paned_set_handle_size(GTK_PANED(mainh),12);
		gtk_paned_set_gutter_size(GTK_PANED(mainh),18);
#ifdef HAVE_GNOME
		gnome_app_set_contents(GNOME_APP(mainwin),mainh);
#else
		gtk_container_add(GTK_CONTAINER(mainwin),mainh);
#endif
		gtk_widget_show(mainh);
		}
		gtk_container_set_border_width(GTK_CONTAINER(mainwin), 5);

		isinit=2;
		}
	else {
		gtk_entry_set_text(GTK_ENTRY(w_master ),"");
		gtk_entry_set_text(GTK_ENTRY(w_player ),"");
		gtk_entry_set_text(GTK_ENTRY(w_member ),"");
		gtk_entry_set_text(GTK_ENTRY(w_message),"");
		gtk_text_set_point(GTK_TEXT(w_msgs),0);
		gtk_text_forward_delete(GTK_TEXT(w_msgs),gtk_text_get_length(GTK_TEXT(w_msgs)));
		}
	dbg(printf("isinit=1\n"));

	ggnconnpriv.r=GGNC_FAIL;

	gtk_window_set_position(GTK_WINDOW(mainwin),GTK_WIN_POS_MOUSE);
	gtk_widget_show(mainwin);

	for (i=0;i<MTT_MAX;i++) {
		dbg(printf("Parsing color %s\n",colornames[i]));
		if (!gdk_color_parse(colornames[i],colortab+i)||!gdk_color_alloc(w_msgs->style->colormap,colortab+i)) {
			dbg(printf("Color %d failed!!!\n",i));
			colortab[i]=mainwin->style->white;
			}
		else dbg(printf("Color %d=(%u,%u,%u)\n",i,colortab[i].red,colortab[i].green,colortab[i].blue));
		}

/* GTK Initialization end */
/**************************/

	safeexit(1);
	fdsetopp=fdsetop;
	notifyggnp=notifyggn;
	presenterrp=presenterr;
	assert(!!LIST_EMPTY(regfds));

	gdkifd=-1;
	gc=NULL;

	ggnunpackstate(*statep);
	mymove();
	gtk_main();
	dbg(printf("gtk_main returned!!!\n"));
	free(*statep); *statep=ggnpackstate();

	gtk_widget_hide(mainwin);
	if (!gc || gc->r!=GGNC_OKAY) ggnabort();
	clearfds();
	clearall();

#ifdef GDK_INPUT_QUIT
{
int tag;
	flagfnflg=0;
	tag=gdk_input_add(1,GDK_INPUT_WRITE,(GdkInputFunction)flagfunc,NULL);
	do gtk_main_iteration();
		while (!flagfnflg);
	gdk_input_remove(tag);
}
#else /* GDK_INPUT_QUIT */
#if 0
{
int tag;
	tag=gtk_idle_add((GtkFunction)gtk_main_quit,NULL);
	gtk_main();
	gtk_idle_remove(tag);
}
#endif
#endif /* GDK_INPUT_QUIT */
	
	if (gc) return(gc);
	ggnconnpriv.r=GGNC_FAIL;
	return(&ggnconnpriv);
}
