#include "ggnprivate.h"
#ifndef lint
static char rcsid[] ATTR_UNUSED = "$Id: ggndmain.c,v 1.1.1.1 1999/09/22 05:07:21 short Exp $";
#endif

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <limits.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <ctype.h>
#include <sys/utsname.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/time.h>
#include <netdb.h>
#include <assert.h>
#include <sys/uio.h>
#include <dirent.h>
#include <math.h>
#include <net/if.h>
#include <sys/ioctl.h>
#include <stddef.h>
#include <errno.h>
#include <stdarg.h>
#ifdef HAVE_SYS_SOCKIO_H
#include <sys/sockio.h>
#endif

#define strcpyl(dest,src,n) do { memcpy((dest),(src),(n)); (dest)[(n)]='\0'; } while (0)
#define forallconn  struct conn *conn,*connext; for (conn=connlist.head;(connext=conn?conn->next:NULL),conn;conn=connext)
#define forallconnx forallconn if (conn!=cmd_conn&&!QUIET(conn))
#define reset_tmout(conn) do { (conn)->tmout.tv_sec=CHAT_TIMEOUT; (conn)->tmout.tv_usec=0; } while (0)
#define SERVSOCK(fd) ((fd)==maintcp||(fd)==mainudp)
#define CHANCONN(cn) ((cn)->chan&&!(cn)->chan->remains)
#define QUIET(cn) (CHANCONN((cn))||(cn)->elect)
#define SOCKADDR_EQ(s,t) ((s).sin_port==(t).sin_port&&(s).sin_addr.s_addr==(t).sin_addr.s_addr)
#define ALONERESET() do { alonetv.tv_sec=MAXALONESEC; alonetv.tv_usec=0; } while (0)

static char linebuf[LINE_MAX];
static int maintcp,mainudp;
static fd_set fdrd,fdwr,fdrdx,fdwrx;
static const char unidentified[]="*unidentified*";
static struct sockaddr_in bestmaster,*broads;
static unsigned broadnum,shotcloses;
static struct timeval broadtv,broadtva,alonetv;
static char imthemaster=1;
static const int val_one=1;
static time_t lastnetconf;

static const char UDPMAGIC[8]="GGNelect";
#define UDPMAGICl sizeof(UDPMAGIC)

struct chan {
	struct chan *next;
	struct conn *list;
	unsigned no,remains;
	};
struct list chanlist;

FDSETOP(fdrd,fdrdx,fdwr,fdwrx)

struct conn {
	struct conn *next;
	struct bufconn b;
	struct conn *chanlink;
	struct timeval tmout;
	unsigned requests;
	char *info,*player,*member;
	struct sockaddr_in addr;
	struct chan *chan;
	unsigned electseq;
	enum { EL_NONE=0, EL_HELLO, EL_FIGHT, EL_QUIT, EL_ZOMBIE } elect;
	int closing:1;
	} *cmd_conn;
struct list connlist;
#define B2CONN(bc) ((struct conn *)(((char *)(bc))-offsetof(struct conn,b)))

static void writefout(struct conn *cn,const char *msg,...)
{
va_list ap;
	va_start(ap,msg);
	writebuf(&cn->b,linebuf,VARVPRINTF(linebuf,msg,ap));
	va_end(ap);
}

static void writeout(const char *msg,...)
{
va_list ap;
	va_start(ap,msg);
	writebuf(&cmd_conn->b,linebuf,VARVPRINTF(linebuf,msg,ap));
	va_end(ap);
}

static struct conn *add_conn(int fd,const char *name)
{
struct conn *cn;
	chk(cn=malloc(sizeof(*cn)));
	cn->b.fd=fd;
	INIT_LIST(cn->b.delwrite);
	INIT_LIST(cn->b.delread);
	cn->b.delreadtot=0;
	reset_tmout(cn);
	cn->b.writecnt=0;
	cn->requests=0;
	cn->closing=0;
	cn->elect=EL_NONE;
	cn->chan=NULL;
	cn->chanlink=NULL;
	cn->b.name=cn->info=cn->player=cn->member=NULL;
	addtail(&connlist,cn);
	FD_SET(fd,&fdrd);
	return cn;
}

static void upd_name(struct conn *cn)
{
	free(cn->b.name);
	saform(&cn->addr);
	chk(cn->b.name=malloc(strlen(saform_buf)+strlen(cn->info)+4));
	sprintf(cn->b.name,"%s [%s]",cn->info,saform_buf);
}

static inline void rem_conn(struct conn *conn)
{
	dbg(printf("Going to remove connection node %p...\n",conn));
	assert(!conn->chanlink&&!conn->chan);
	if (!QUIET(conn)&&shotcloses&&safegot) shotcloses--;
	remmid(&connlist,conn);
	FD_CLR(conn->b.fd,&fdrd);
	FD_CLR(conn->b.fd,&fdwr);
	dbg(printf("rem_conn: delwrite...\n"));
	rem_bp(&conn->b.delwrite);
	dbg(printf("rem_conn: delread...\n"));
	rem_bp(&conn->b.delread);
	if (close(conn->b.fd)) errout("&^close(%s)",conn->b.name);
#ifdef DEBUGIO
	printf("%02u - closed\n",conn->b.fd);
#endif
	free(conn->b.name);
	if (conn->info!=unidentified) free(conn->info);
	assert(!conn->player&&!conn->member);
	free(conn);
	if (!shotcloses&&safegot) exit(EXIT_SUCCESS);
	dbg(printf("Remove of the connection node %p succeeded!\n",conn));
}

static inline struct conn *getconn(int fd)
{
struct conn *res;
	dbg(printf("Searching for conn %d...\n",fd));
	for (res=connlist.head;res&&res->b.fd!=fd;res=res->next);
	dbg(printf("Got conn %p.\n",res));
	assert(!!res);
	return res;
}

static void closeconn(struct bufconn *bcn)
{
struct conn *cn=B2CONN(bcn),*cn2,*cn3;
	dbg(printf("Requested to close connection %p\n",cn));
	cn->closing=1;
	FD_CLR(cn->b.fd,&fdrd);
	if (cn->player) { forallconnx
		writefout(conn,PLAYERDISCONNECT,cn->player);
		}
	destroy(cn->player);
	destroy(cn->member);
	if (!cn->chan) return;
	if (CHANCONN(cn)||cn->chanlink==cn) {
		dbg(printf("Channel %p will be destroyed\n",cn->chan));
		for (cn2=cn->chanlink;cn2!=cn;cn2=cn3) {
			dbg(printf("Closing connection %p\n",cn2));
			cn2->closing=1;
			FD_CLR(cn2->b.fd,&fdrd);
			cn2->chan=NULL;
			cn3=cn2->chanlink;
			cn2->chanlink=NULL;
			}
		dbg(printf("Removing channel %p(%u)\n",cn->chan,cn->chan->no));
		remmid(&chanlist,cn->chan);
		}
	else {
		cn->chan->remains++;
		for (cn2=cn->chanlink;;cn2=cn2->chanlink) {
			writefout(cn2,"004 %s has disconnected, waiting yet for %u remaining.\n",cn->b.name,cn->chan->remains);
			if (cn2->chanlink==cn) break;
			}
		cn2->chanlink=cn->chanlink;
		if (cn->chan->list==cn)
			cn->chan->list=cn->chanlink;
		}
	cn->chan=NULL;
	cn->chanlink=NULL;
}

static inline void show_prompt(struct conn *cn)
{
static const char promptbuf[]=">";
	writebuf(&cn->b,promptbuf,strlen(promptbuf));
}

static struct conn *establish(const struct sockaddr_in *saddrp,const char *fmtstr,const char *name)
{
int sk,err;
struct conn *cn;
#define saddr (*saddrp)

	saform(&saddr);
	if ((sk=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP))==-1) {
		err=errno; errout("&^socket()");
		goto connfail;
		}
	if (connect(sk,(struct sockaddr *)&saddr,sizeof(saddr))) { /* Blocking!!! */
		err=errno;
		errno=err; errout("&^connect(%s)",saform_buf);
connfail:
		writeout("204 Connect to \"%s\" failed: %s\n",saform_buf,strerror(err));
		if (close(sk)) errout("&^close()");
		return(NULL);
		}
#ifdef DEBUGIO
	printf("%02u - established to %s\n",sk,saform_buf);
#endif
	cn=add_conn(sk,saform_buf);
	cn->addr=saddr;
	chk(cn->info=malloc(strlen(fmtstr)-2+strlen(name)+1));
	sprintf(cn->info,fmtstr,name);
	upd_name(cn);
	return(cn);
#undef saddr
}

static inline void udprequest(const struct sockaddr_in *sap)
{
struct conn *cn;
	dbg(printf("UDP request from %s.\n",saform(sap)));
	if (SOCKADDR_EQ(*sap,localsaddr)||INADDR_LOOPBACK==ntohl(sap->sin_addr.s_addr)) {
		dbg(printf("Ignoring local UDP echo\n"));
		return;
		}
	ALONERESET();
	if (!imthemaster) {
		dbg(printf("UDP request from %s (!master).\n",saform(sap)));
		if (SOCKADDR_EQ(*sap,bestmaster)) return;
		bestmaster=*sap;
		saform(&bestmaster);
		{ forallconn
			if (!QUIET(conn)) writefout(conn,BETTERMASTER,saform_buf);
			}
		return;
		}
	dbg(printf("UDP request from %s (master).\n",saform(sap)));
	{ forallconn
		if (conn->elect&&SOCKADDR_EQ(conn->addr,*sap)) {
			dbg(printf("Already in fight\n"));
			return;
			}
		}
	if (!(cn=establish(sap,"election by UDP broadcast against%s",""))) return;
	writefout(cn,"hello %s\n",localtaddr);
	cn->elect=EL_HELLO;
}

static inline void doaccept(int srvsock)
{
struct sockaddr_in saddr;
int newsock;
socklen_t saddr_len=sizeof(saddr);
struct conn *cn;

	assert(SERVSOCK(srvsock));
	if (srvsock==mainudp) {
int i;

		if ((i=recvfrom(srvsock,linebuf,UDPMAGICl,0,
				(struct sockaddr *)&saddr,&saddr_len))==-1) {
#ifdef UDP_ERRORS
			errout("&^Packet read error on udp/%u port",SERVICE_PORT);
#endif
			return; }
		else if (i!=UDPMAGICl||memcmp(UDPMAGIC,linebuf,UDPMAGICl)) {
#ifdef UDP_ERRORS
			errout("&Bogus packet on udp/%u port",SERVICE_PORT);
#endif
			return; }
		udprequest(&saddr);
		return;
		}
	if ((newsock=accept(maintcp,(struct sockaddr *)&saddr,&saddr_len))<0) {
		errout("&^accept(maintcp)");
		return;
		}
	dbg(printf("accepted new connection %d.\n",newsock));
	saform(&saddr);
#ifdef DEBUGIO
	printf("%02u - accepted from %s\n",newsock,saform_buf);
#endif
	cn=add_conn(newsock,saform_buf);
	cn->addr=saddr;
	cn->info=(char *)unidentified;
	upd_name(cn);
	dbg(printf("add_conn() in doaccept() passed.\n"));
	writefout(cn,"\
000 This is Generic Game Network server (v" VERSION ") on host %s [%s].\n\
000 %s, please identify yourself (\"hello\").\n\
",localhostname,localtaddr,cn->b.name);
	dbg(printf("writefout() in doaccept() passed.\n"));
	show_prompt(cn);
}

static int parse_num(const char *arg,int *valp,int minn)
{
long val;
char *s;
	val=strtol(arg,&s,0);
	if (val<=INT_MIN||val>=INT_MAX||*s||val<minn) {
		writeout("200 Number parsing error: \"%s\"\n",arg);
		return 1;
		}
	*valp=val;
	return 0;
}

static void fn_quit(void)
{
	writeout("101 Closing connection...\n");
	closeconn(&cmd_conn->b);
}

static struct chan *newchan(int numbered)
{
unsigned num=0;
struct chan *chan;
	if (numbered)
		for (num=1;;num++) {
			for (chan=chanlist.head;chan&&chan->no!=num;chan=chan->next);
			if (!chan) break;
			}
	chk(chan=malloc(sizeof(*chan)));
	chan->no=num;
	addtail(&chanlist,chan);
	return(chan);
}

static int identied(void)
{
	if (cmd_conn->info!=unidentified) return(1);
	writeout("209 Filled identity required for command processing - use \"hello\"\n");
	return(0);
}

static int playerid(void)
{
	if (cmd_conn->player) return(1);
	writeout("211 Player name required for command processing - use \"player\"\n");
	return(0);
}

static void fn_hello(void)
{
	if (cmd_conn->info!=unidentified) free(cmd_conn->info);
	cmd_conn->info=strdup(cmdpars[0]);
	upd_name(cmd_conn);
	writeout("100 Identity accepted: \"%s\"\n",cmd_conn->info);
	if (!imthemaster)
		writeout(BETTERMASTER,saform(&bestmaster));
	{ forallconnx
		if (conn->player) {
			writeout(NEWPLAYER,conn->player,conn->info);
			if (conn->member)
				writeout(PLAYERMEMBER,conn->player,conn->member);
			}
		}
}

static void distrib(struct conn *conn,const char *buf,size_t len)
{
struct conn *cn;
int no=1;

	assert(CHANCONN(conn));
	dbg(printf("connection %p in channel mode - distributing...\n",conn));
	if (conn->chan->no) {
		cn=conn->chan->list;
		for (no=1;cn!=conn;cn=cn->chanlink) no++; /* FIXME: ineffective, cacheit */
		}
	for (cn=conn->chanlink;cn!=conn;cn=cn->chanlink) {
		dbg(printf("writing data from %p to node %p\n",conn,cn));
		if (conn->chan->no) writefout(cn,"%d:",no);
		writebuf(&cn->b,buf,len);
		if (conn->chan->no) writefout(cn,"\n",1);
		}
	dbg(printf("delivery completed by request, aye aye sir\n"));
}

static void chanline(char *buf,struct bufconn *bconn)
{ /* s~tub! */
struct conn *conn=B2CONN(bconn);
	dbg(printf("in chanline,strlen=%d\n",strlen(buf)));
	distrib(conn,buf,strlen(buf));
}

static void flushread(struct chan *chan)
{
struct conn *cn=chan->list;

	dbg(printf("Flushing read buffers for %p...\n",chan));
	assert(!chan->remains);
	for (;;) {
		assert(cn->chan==chan);
		if (!chan->no) {
			while (!LIST_EMPTY(cn->b.delread)) {
	struct bufpart *bp=remhead(&cn->b.delread);
				distrib(cn,bp->buf+bp->done,bp->len-bp->done);
				freebufpart(bp);
				}
			cn->b.delreadtot=0;
			}
		else linefuncize(&cn->b,NULL,chanline);
		if ((cn=cn->chanlink)==chan->list) return;
		}
	dbg(printf("Flushed read buffers for %p\n",chan));
}

struct sockaddr_in getsaddr_buf;
static struct sockaddr_in *getsaddrx(const char *s)
{
char *s2;
union {
	unsigned s4;
	unsigned char s1[4];
	} v;
int i;
long l;

	for (i=0;i<4;i++) {
		l=strtol(s,&s2,10);
		if ((*s2!='.'&&*s2!=':')||(*s2=='.'&&i==3)||(*s2==':'&&i<3)||l<0||l>255)
			return(NULL);
		v.s1[3-i]=l;
		s=s2+1;
		}
	l=strtol(s,&s2,10);
	if (l<0||l>65535||*s2!='\0') return(NULL);
#define saddr getsaddr_buf
	saddr.sin_family=AF_INET;
	saddr.sin_port=htons(l);
	saddr.sin_addr.s_addr=htonl(v.s4);
	return(&saddr);
#undef saddr

}

static struct sockaddr_in *getsaddr(void)
{
char *s;
struct sockaddr_in *r;

	dbg(printf("getsaddr: \"%s\"\n",cmdpars[0]));
	if (strchr(cmdpars[0],'!')) {
		writeout("201 Proxied paths not supported on server side\n");
		return(NULL);
		}
	for (s=cmdpars[0];*s;s++)
		if (!ISC(*s,digit)&&*s!=':'&&*s!='.') {
			writeout("202 DNS resolving not supported on server side\n");
			return(NULL);
			}
	if (!(r=getsaddrx(cmdpars[0]))) {
		writeout("203 \"a.b.c.d:p\" format required\n");
		return(NULL);
		}
	return(r);
}

static void fn_proxy(void)
{
struct conn *cn;
struct chan *chan;

	if (!getsaddr()) return;
	if (!(cn=establish(&getsaddr_buf,"proxy from %s to",cmd_conn->b.name))) return;

	chan=newchan(0);
	chan->remains=0;
	cmd_conn->chan=chan;
	cn      ->chan=chan;
	chan->list=cmd_conn;
	cmd_conn->chanlink=cn;
	cn      ->chanlink=cmd_conn;
	flushread(chan);
	dbg(printf("Proxy channel %p has been setup\n",chan));
	writeout("103 Proxying to %s and leaving...\n",saform_buf);
}

static unsigned getelval(unsigned seq)
{
	switch (seq) {
		case 0:  assert(0);
		case 1:  return(ELECTLEVEL);
		case 2:  return(((unsigned)clock())%ELECT_VAL_MOD);
		default: return(((unsigned)rand ())%ELECT_VAL_MOD);
		}
}

static void challengel(struct conn *cn)
{
	cn->electseq++;
	writefout(cn,"fight %u,%u\n",getelval(cn->electseq),cn->electseq);
}

static void fn_elect(void)
{
struct conn *cn;
	if (!getsaddr()) return;
	if (INADDR_LOOPBACK==ntohl(getsaddr_buf.sin_addr.s_addr)) {
		writeout("213 Refusing to elect on loopback (%s)\n",saform(&getsaddr_buf));
		return;
		}
	if (!(cn=establish(&getsaddr_buf,"election by cmd %s against",cmd_conn->b.name))) return;
	writefout(cn,"hello %s\n",localtaddr);
	cn->elect=EL_HELLO;
}

static void setbetter(struct sockaddr_in *addr)
{
	bestmaster=*addr;
	imthemaster=0;
	ALONERESET();
	timerclear(&broadtv);
	timerclear(&broadtva);
	saform(addr);
	{ forallconn
		if (!QUIET(conn)) writefout(conn,BETTERMASTER,saform_buf);
		}
}

static void fn_fight(void)
{
int val,seq,my;
struct sockaddr_in addr;

	dbg(printf("fn_fight()\n"));
	if (parse_num(cmdpars[0],&val,0)) return;
	if (parse_num(cmdpars[1],&seq,1)) return;
	if ((my=getelval(seq))==val) {
		writeout("212 Elect challenge equal, retry with successor (or upgrade?)\n");
		return;
		}
	if (my<val&&getsaddrx(cmd_conn->info)) {
		addr=getsaddr_buf;
		writeout("108 Election loosen, redirecting clients: \"%s\"\n",
			saform(&addr));
		setbetter(&addr);
		return;
		}
	writeout("107 Won the election, staying serving\n");
}

static void fn_channel(void)
{
int num;
unsigned tot,cur;
struct chan *chan;
struct conn *cn;

	if (parse_num(cmdpars[0],&num,INT_MIN)) return;
	if (num>=0) {
		for (chan=chanlist.head;chan&&chan->no!=num;chan=chan->next);
		if (!chan) {
			writeout("207 Channel %d doesn't exist\n",num);
			return;
			}
		if (!chan->remains) {
			writeout("208 Channel %d is already setup\n",num);
			return;
			}
		chan->remains--;
		tot=2;
		for (cn=chan->list->chanlink;cn!=chan->list;cn=cn->chanlink) tot++;
		cur=1;
		for (cn=chan->list;;cn=cn->chanlink) {
			if (chan->remains)
				writefout(cn,"003 %s joined, waiting for %u remaining.\n",cmd_conn->b.name,chan->remains);
			else {
				writefout(cn,"106 %s joined, setting up channel mode, leaving: %u,%u\n",cmd_conn->b.name,cur,tot);
#if 0
				FD_SET(cn->b.fd,&fdrd);
#endif
				}
			cur++;
			if (cn->chanlink==chan->list) break;
			}
		cn->chanlink=cmd_conn;
		cmd_conn->chanlink=chan->list;
		if (chan->remains) {
			writeout("115 Joined to channel %d, waiting still for %u members\n",num,chan->remains);
#if 0
			FD_CLR(cmd_conn->b.fd,&fdrd);
#endif
			}
		else {
			writeout("115 Joined to channel %d\n",num);
			writeout("106 Joined to channel %d, setting up channel mode, leaving: %u,%u\n",num,cur,tot);
			}
		}
	else {
		chan=newchan(1);
		chan->list=cmd_conn;
		chan->remains=-num;
		cmd_conn->chanlink=cmd_conn;
		writeout("105 Channel created, waiting for %d members: %u\n",-num,chan->no);
#if 0
		FD_CLR(cmd_conn->b.fd,&fdrd);
#endif
		}
	cmd_conn->chan=chan;
	if (!chan->remains) flushread(chan);
}

static void fn_player(void)
{
	if (!identied()) return;
	dbg(printf("fn_player(\"%s\")\n",cmdpars[0]));
	{ forallconnx
		if (conn->player&&!strcmp(conn->player,cmdpars[0])) {
			writeout("210 Player name already exists, use another: \"%s\"\n",conn->player);
			return;
			}
		}
	if (cmd_conn->player) {
		{ forallconnx
			writefout(conn,PLAYERDISCONNECT,cmd_conn->player);
			}
		destroy(cmd_conn->player);
		}
	destroy(cmd_conn->member);
	if (*cmdpars[0]) {
		chk(cmd_conn->player=strdup(cmdpars[0]));
		{ forallconnx
			writefout(conn,NEWPLAYER,cmd_conn->player,cmd_conn->info);
			}
		}
	writeout("111 Player identity accepted: \"%s\"\n",(cmd_conn->player?cmd_conn->player:""));
}

static void fn_member(void)
{
	if (!playerid()) return;
	{ forallconnx
		writefout(conn,PLAYERMEMBER,cmd_conn->player,cmdpars[0]);
		}
	destroy(cmd_conn->member);
	if (*cmdpars[0]) {
		chk(cmd_conn->member=strdup(cmdpars[0]));
		}
	writeout("112 Player considered as member: \"%s\",\"%s\"\n",
		(cmd_conn->player?cmd_conn->player:""),(cmd_conn->member?cmd_conn->member:""));
}

static void fn_start(void)
{
	if (!playerid()) return;
	{ forallconnx
		writefout(conn,"304 Starting netgame: \"%s\",\"%s\",\"%s\",\"%s\"\n",
			cmd_conn->player,cmdpars[0],cmdpars[1],cmdpars[2]);
		}
	writeout("114 Netgame start ok: \"%s\",\"%s\",\"%s\"\n",cmdpars[0],cmdpars[1],cmdpars[2]);
}

static void fn_say(void)
{
	if (!identied()) return;
	{ forallconnx
		writefout(conn,"305 Message from %s: \"%s\",\"%s\"\n",
			(cmd_conn->player?"player":"hostpath"),
			(cmd_conn->player?cmd_conn->player:cmd_conn->info),cmdpars[0]);
		}
	writeout("113 Message accepted for delivery\n");
}

static void getnetconf(void)
{
unsigned cnt=MAX_BRDINTERFACES,i,j;
struct ifconf ifconf;

	dbg(printf("Rebuilding broadcast list\n"));
	free(broads);
#ifdef SIOCGIFCOUNT
	if (ioctl(mainudp,SIOCGIFCOUNT,&cnt))
		{ /*errout("&^ioctl(udp,SIOCGIFCOUNT)");*/ }
	else {
		dbg(printf("Got %u interfaces\n",cnt));
		cnt=cnt*2+2;
		}
#endif

	chk(ifconf.ifc_req=(void *)alloca((ifconf.ifc_len=cnt*sizeof(struct ifreq))));
	if (ioctl(mainudp,SIOCGIFCONF,&ifconf)||ifconf.ifc_len%sizeof(struct ifreq))
		errout("^ioctl(udp,SIOCGIFCONF)");
	cnt=ifconf.ifc_len/sizeof(struct ifreq);
	dbg(printf("Got %u interfaces in real\n",cnt));
	chk(broads=malloc(cnt*sizeof(*broads)));
	for (i=j=0;i<cnt;i++) {
		if (ioctl(mainudp,SIOCGIFFLAGS,ifconf.ifc_req+i))
			errout("^ioctl(udp,\"%s\",SIOCGIFFLAGS)",ifconf.ifc_req[i].ifr_name);
		if (((ifconf.ifc_req[i].ifr_flags&IF_REQFLAGS)!=IF_REQFLAGS)||
				 (ifconf.ifc_req[i].ifr_flags&IF_NOTFLAGS))
			continue;
		if (ioctl(mainudp,(ifconf.ifc_req[i].ifr_flags&IFF_BROADCAST?SIOCGIFBRDADDR:SIOCGIFDSTADDR),ifconf.ifc_req+i))
			errout("^ioctl(udp,\"%s\",SIOCGIF{DST/BRD}ADDR)",ifconf.ifc_req[i].ifr_name);

		assert(sizeof(broads[i])==sizeof(ifconf.ifc_req[i].ifr_broadaddr));
		broads[j]=*(struct sockaddr_in *)&ifconf.ifc_req[i].ifr_broadaddr;
		broads[j].sin_family=AF_INET;
		broads[j].sin_port=htons(SERVICE_PORT);
		dbg(printf("Adding socket broadcast %s (%s)\n",saform(broads+j),ifconf.ifc_req[i].ifr_name));
		j++;
		}
	chk(broads=realloc(broads,sizeof(*broads)*(broadnum=j)));
	dbg(printf("Read %u interfaces. Final result.\n",j));
	lastnetconf=time(NULL);
}

static int subtv(struct timeval *a,const struct timeval *b)
{
	if ((a->tv_usec-=b->tv_usec)<0) {
		a->tv_usec+=1000000;
		a->tv_sec--;
		}
	a->tv_sec-=b->tv_sec;
	if (a->tv_sec<0) return -1;
	return(timerisset(a));
}

static int addtv(struct timeval *a,const struct timeval *b)
{
	if ((a->tv_usec+=b->tv_usec)>=1000000) {
		a->tv_usec-=1000000;
		a->tv_sec++;
		}
	a->tv_sec+=b->tv_sec;
	return(timerisset(a));
}

static void broadcast(void)
{
unsigned i;

	if (time(NULL)-lastnetconf>=MAXNETCONFTIME) getnetconf();
	dbg(printf("Sending broadcast...\n"));
	for (i=0;i<broadnum;i++)
		if (sendto(mainudp,UDPMAGIC,UDPMAGICl,0,(struct sockaddr *)(broads+i),sizeof(*broads))!=UDPMAGICl)
			errout("&^sendto(udp,%s)",saform(broads+i));
	broadtv=broadtva;
	addtv(&broadtva,&broadtv);
	if (broadtva.tv_sec>=MAXBROADSEC) {
		broadtva.tv_sec=MAXBROADSEC;
		broadtva.tv_usec=0;
		}
	broadtv=broadtva;
	dbg(printf("Broadcast sent...\n"));
}

static void rebroad(void)
{
	imthemaster=1;
	timerclear(&alonetv);
	broadtva.tv_sec =INIBROADSEC;
	broadtva.tv_usec=INIBROADUSEC;
	broadcast();
}

static void fn_rebroad(void)
{
	if (imthemaster) writeout("109 Restarted local master broadcasting\n");
	else writeout("110 Became local master and broadcasting (best was %s - dead?)\n",saform(&bestmaster));
	rebroad();
}

static void fn_help(void);

static const struct {
	const char *name;
	const unsigned char npars;
	void (*fnc)(void);
	const char *help;
} cmdtable[]={
	{"hello"   ,1,fn_hello   ,"Identify as from hostpath[1]"},
	{"proxy"   ,1,fn_proxy   ,"Establish connection to hostaddr[1]"},
	{"channel" ,1,fn_channel ,"Establish/join channel #[1] (<0=create w/-num)"},
	{"player"  ,1,fn_player  ,"Set connection player name/\"\"[1]"},
	{"member"  ,1,fn_member  ,"Declare yourself as member of game[1]"},
	{"start"   ,3,fn_start   ,"Start netgame[1] on server[2] channel[3]"},
	{"say"     ,1,fn_say     ,"Broadcast message[1] as 305"},
	{"elect"   ,1,fn_elect   ,"Challenge server[1] for mastering"},
	{"fight"   ,2,fn_fight   ,"Evaluate mastering fight n-th[2] challenge[1]"},
	{"rebroad" ,0,fn_rebroad ,"Restart announce broadcasts"},
	{"help"    ,0,fn_help    ,"This help"},
	{"quit"    ,0,fn_quit    ,"Close connection"},
	{"exit"    ,0,fn_quit    ,"Close connection"},
};
#define CMDTABLE_SIZE (sizeof(cmdtable)/sizeof(*cmdtable))

static void fn_help(void)
{
int i;
	writeout("000 Available commands:\n");
	for (i=0;i<CMDTABLE_SIZE;i++)
		writeout("000 %-8s[%d] - %s\n",cmdtable[i].name,cmdtable[i].npars,cmdtable[i].help);
	writeout("102 Help end.\n");
}

static inline void electresponse(char *buf,struct conn *conn)
{
int code,i;
char *s=buf;

	dbg(printf("Taking as election response.\n"));
	assert(!!conn->elect);
	while (*s=='>') s++;
	for (i=0;i<4;i++)
		if ((i<3&&!ISC(s[i],digit))||(i==3&&s[i]!=' ')) {
			errout("&Unprocessable election response on %s",conn->b.name);
			goto err;
			}
	if (*s=='0'||*s=='3') return; /* Informational */
	code=atoi(s);
	if (code==100&&conn->elect==EL_HELLO) { /* Identity accepted */
		conn->elect=EL_FIGHT;
		conn->electseq=0;
		challengel(conn);
		return;
		}
	if (code==108&&conn->elect==EL_FIGHT) { /* Election loosen, redirecting clients to */
		conn->elect=EL_QUIT;
		writefout(conn,"quit\n");
		return;
		}
	if (code==212&&conn->elect==EL_FIGHT) { /* Elect challenge equal, retry with successor (or upgrade?) */
		challengel(conn);
		return;
		}
	if (code==107&&conn->elect==EL_FIGHT) { /* Won the election, staying serving */
		setbetter(&conn->addr);
		conn->elect=EL_QUIT;
		writefout(conn,"quit\n");
		return;
		}
	if (code==101&&conn->elect==EL_QUIT) { /* Closing connection... */
		}
	else errout("&Unexpected election response on %s: \"%s\"",conn->b.name,buf);
err:
	conn->elect=EL_ZOMBIE;
	closeconn(&conn->b);
}

static inline void shotdown(void)
{
	if (imthemaster&&!SOCKADDR_EQ(bestmaster,localsaddr)) {
		saform(&bestmaster);
		{ forallconn
			if (!QUIET(conn)) writefout(conn,BETTERMASTER,saform_buf);
			}
		}
	{ forallconn {
		if (!QUIET(conn)) writefout(conn,"402 Shutting down the server - brutal close follows\n");
		closeconn(&conn->b);
		shotcloses++;
		}}
	if (!shotcloses) exit(EXIT_SUCCESS);
}

static void proccmd(char *buf,struct bufconn *bconn)
{
struct conn *conn=B2CONN(bconn);
char *s,*cmds;
int i;

	if (conn->elect) {
		electresponse(buf,conn);
		return;
		}
	dbg(printf("Taking as command.\n"));
	for (cmds=buf;*cmds&&ISC(*cmds,space);cmds++);
	for (s=cmds;*s&&!ISC(*s,space);s++);
	if (s==cmds) { writefout(conn,"104 Empty command.\n"); goto emptycmd; }
	parsepars(s);
	for (i=0;i<CMDTABLE_SIZE;i++)
		if (!strcmp(cmdtable[i].name,cmds)) break;
	if (i!=CMDTABLE_SIZE)
		if (cmdtable[i].npars!=cmdpar)
			writefout(conn,"205 %d parameter%s found, %d expected!\n",cmdpar,(cmdpar==1?"":"s"),cmdtable[i].npars);
		else {
			cmd_conn=conn;
			(*cmdtable[i].fnc)();
			conn->requests++;
			}
	else writefout(conn,"206 Unknown command \"%s\"!\n",cmds);
emptycmd:
	if (!conn->closing&&!conn->chan) show_prompt(conn);
}

static void tryread(int fd)
{
int got; /* warn: size_t is unsigned! */
struct conn *conn=getconn(fd);

	if (conn->closing) return;
	dbg(printf("tryread %p(%d)\n",conn,fd));
	if ((got=read(fd,linebuf,sizeof(linebuf)))<=0) {
		if (!got)
			dbg(printf("Reading returned 0 - Closing connection\n"));
		else dbg(printf("Read error\n"));
		if (got) errout("&^read(%s)",conn->b.name);
		if (!QUIET(conn))
			writefout(conn,"401 Eeek! End reached, closing connection.\n");
		closeconn(&conn->b);
		return;
		}
	dbg(printf("tryread got %d\n",got));
	reset_tmout(conn);
#ifdef DEBUGIO
	printf("%02u>>",fd);
	fwrite(linebuf,got,1,stdout);
	if (linebuf[got-1]!='\n') puts("\\");
#endif
	if (CHANCONN(conn)&&!conn->chan->no) distrib(conn,linebuf,got);
	else addfrag(&conn->b,linebuf,got,(conn->chan?(CHANCONN(conn)?chanline:NULL):proccmd));
}

static void sigparent(void)
{
	if (kill(getppid(),SIGNAL_NAME))
		errout("^Signalling parent");
}

static int getlsock(int sockt,int proto,const char *tcudp,int signo)
{
int s;
struct sockaddr_in anyaddr;

	if ((s=socket(AF_INET,sockt,proto))==-1)
		errout("^socket()");
	if (setsockopt(s,SOL_SOCKET,SO_REUSEADDR,(void *)&val_one,sizeof(val_one)))
		errout("&^setsockopt(s,SO_REUSEADDR)");
	if (fcntl(s,F_SETFL,O_NONBLOCK))
		errout("&^fcntl(s,O_NONBLOCK)");

	anyaddr.sin_family=AF_INET;
	anyaddr.sin_port=htons(SERVICE_PORT);
	anyaddr.sin_addr.s_addr=htonl(INADDR_ANY);
	dbg(printf("Got main%s port sin_port=%u\n",tcudp,ntohs(anyaddr.sin_port)));
	if (bind(s,(struct sockaddr *)&anyaddr,sizeof(anyaddr))) {
		if (errno!=EADDRINUSE||signo==-1) errout("^bind(s)");
		sigparent();
		exit(EXIT_FAILURE);
		}
	FD_SET(s,&fdrd);
	return(s);
}

static inline void gensrand(void)
{
int fd=open("/dev/random",O_RDONLY
#ifdef O_BINARY
|O_BINARY
#endif
);
unsigned seed=time(NULL);

	if (fd) {
		read(fd,&seed,sizeof(seed));
		close(fd);
		}
	srand(seed);
}


int ggnd_main(int argc,char **argv,int pipefd)
{
int totgot,fd,maxfd;
struct timeval tv,tva;
int signo=(pipefd==-1?-1:SIGNAL_NAME);

	closeconnp=closeconn;
	fdsetopp=fdsetop;
	gensrand();
	FD_ZERO(&fdrd);
	FD_ZERO(&fdwr);
	getlocalname();

	maintcp=getlsock(SOCK_STREAM,IPPROTO_TCP,"tcp",signo);
	if (listen(maintcp,DEFAULT_BACKLOG)) errout("^listen(s)");
	mainudp=getlsock(SOCK_DGRAM ,IPPROTO_UDP,"udp",signo);
	if (setsockopt(mainudp,SOL_SOCKET,SO_BROADCAST,(void *)&val_one,sizeof(val_one)))
		errout("&^setsockopt(s,SO_BROADCAST)");
	getnetconf();
	bestmaster=localsaddr;

	INIT_LIST(connlist);
	INIT_LIST(chanlist);

	rebroad();

	safeexit(0);

	if (pipefd!=-1) {
		sigparent();
		FD_SET(pipefd,&fdrd);
		}

	for (;;) {
		fdwrx=fdwr;
		fdrdx=fdrd;
		tv=broadtv;
		if (timerisset(&alonetv)&&(!timerisset(&tv)||timercmp(&tv,&alonetv,>))) tv=alonetv;
		maxfd=MAX(MAX(maintcp,mainudp),pipefd);
		{ forallconn {
			if (!timerisset(&tv)||timercmp(&tv,&conn->tmout,>)) tv=conn->tmout;
			if (conn->b.fd>maxfd) maxfd=conn->b.fd;
			}}
		dbg(printf("Entering select (maxfd=%d, tv=%ld:%ld)...\n",maxfd,tv.tv_sec,tv.tv_usec));
		tva=tv;
		if ((totgot=select(maxfd+1,&fdrdx,&fdwrx,NULL,(timerisset(&tv)?&tv:NULL)))<0) {
			dbg(printf("Select() failed!!!\n"));
			if (errno==EINTR&&safegot) { shotdown(); continue; }
			errout("^select()");
			}
		subtv(&tva,&tv);
		dbg(printf("Select returned totgot=%d (tva=%ld:%ld, tv=%ld:%ld)...\n",totgot,tva.tv_sec,tva.tv_usec,tv.tv_sec,tv.tv_usec));
		{ forallconn {
			if (subtv(&conn->tmout,&tva)>0) continue;
			writefout(conn,"400 Idle time %d minutes exceeded, logging out!\n",CHAT_TIMEOUT/60);
			closeconn(&conn->b);
			}
		}
		if (timerisset(&broadtv)) if (subtv(&broadtv,&tva)<=0) broadcast();
		if (timerisset(&alonetv)) if (subtv(&alonetv,&tva)<=0) rebroad();
		for (fd=0;fd<=maxfd&&totgot>=0;fd++) {
			if (FD_ISSET(fd,&fdwrx)) {
				totgot--;
				if (FD_ISSET(fd,&fdwr)) trywrite(&getconn(fd)->b);
				}
			if (FD_ISSET(fd,&fdrdx)) {
				totgot--;
				if (FD_ISSET(fd,&fdrd)) {
					if (SERVSOCK(fd)) doaccept(fd);
					else if (fd==pipefd) {
						dbg(printf("My parent has probably died, dying with him (her?)\n"));
						shotdown();
						FD_CLR(pipefd,&fdrd);
						}
					else tryread(fd);
					}
				}
			}
		assert(!totgot);
		{ forallconn
			if (conn->closing&&LIST_EMPTY(conn->b.delwrite)) rem_conn(conn);
			}
		}
	return(EXIT_SUCCESS);
}
