#ifndef _GGNINTL_H
#define _GGNINTL_H

/*
 * $Id: ggnintl.h,v 1.3 2000/06/21 03:11:36 short Exp $
 */

/*
 * Handles all of the internationalization configuration options.
 * Author: Tom Tromey <tromey@creche.cygnus.com>
 * Stolen from <libgnome/gnome-i18n.h>
 * Modified by Jan Kratochvil <short@ucw.cz>
 */
#ifdef HAVE_GNOME
#include <gnome.h>
#else
#ifdef ENABLE_NLS
#ifdef HAVE_LIBINTL_H
#    include <libintl.h>
#endif /* !HAVE_GNOME && HAVE_LIBINTL_H */
#    ifdef gettext_noop
#        define N_(String) gettext_noop (String)
#    else
#        define N_(String) (String)
#    endif
#else /* !HAVE_GNOME && ENABLE_NLS */
/* Stubs that do something close enough.  */
#    define textdomain(String) (String)
#    define gettext(String) (String)
#    define dgettext(Domain,Message) (Message)
#    define dcgettext(Domain,Message,Type) (Message)
#    define bindtextdomain(Domain,Directory) (Domain)
#    define N_(String) (String)
#endif /* !HAVE_GNOME && ENABLE_NLS */
#endif /* HAVE_GNOME */
#    undef _
#    define _(String) dgettext (PACKAGE,String)

#include <locale.h>
#include <stdio.h>

#define INITLOCALE(pname) \
	do { if (!setlocale(LC_ALL,"")) \
	fprintf(stderr,"%s: Locale not supported by C library!\n",(pname)); \
	} while (0)

#endif /* _GGNINTL_H */
