#ifndef _GGNPRIVATE_H
#define _GGNPRIVATE_H

/*
 * $Id: ggnprivate.h,v 1.1.1.1 1999/09/22 05:07:21 short Exp $
 */

#include "config.h"
/* AIX requires this to be the first thing in the file.  */
/*#ifndef __GNUC__*/
# if HAVE_ALLOCA_H
#  include <alloca.h>
# else
#  ifdef _AIX
 #pragma alloca
#  else
#   ifndef alloca /* predefined by HP cc +Olibcalls */
char *alloca ();
#   endif
#  endif
# endif
/*#endif*/

#include "ggnintl.h"

#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <assert.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <ctype.h>

#include "ggn.h"

__BEGIN_DECLS

#ifndef NDEBUG

/* #define DEBUG */
/* #define DEBUGIO */
/* #define GGND_VERBOSE */

/* FIXME: UDP_ERRORS can cause failure to start netgame! */
/* #define UDP_ERRORS */

#endif /* NDEBUG */

#define CHAT_TIMEOUT (15*60)
#define CHAN_TIMEOUT (60*60)
#define CMD_MAXPARS 5
#define SERVICE_PORT 3252
#define DEFAULT_BACKLOG 5
#define USE_WRITEV
#define ELECTLEVEL 100
#define MAXBROADSEC 30
#define INIBROADSEC 0
#define INIBROADUSEC 100000
#define MAXALONESEC (MAXBROADSEC*3)
#define MAXNETCONFTIME (5*60)
#define BETTERMASTER     "300 Current best network master: \"%s\"\n"
#define NEWPLAYER        "301 New player connected: \"%s\",\"%s\"\n"
#define PLAYERDISCONNECT "302 Player disconnected: \"%s\"\n"
#define PLAYERMEMBER     "303 Player is member: \"%s\",\"%s\"\n"
#define IF_REQFLAGS (IFF_UP|IFF_RUNNING)
#define IF_NOTFLAGS (IFF_LOOPBACK)
#define SAFORM_BUF_SIZ 128
#define MAX_BRDINTERFACES 16
#define ELECT_VAL_MOD 1000000
#define MIN_OKAY_REDIRECT 3
#define DAEMONWAITSEC 3

#define MAX_REDIRECTS 5
#define SIGNAL_NAME SIGUSR2
#define DAEMON_FMT "%s (ggnd)"
#define DAEMON_KILL_TIME 3
#define STARTUP_DELAY 1
#define GGN_DEFAULT_STATE ""

#define STR_EQ(a,b) ((a)==(b)||((a)&&(b)&&!strcmp((a),(b))))
#define ISC(x,t) is##t((int)(unsigned char)(x))

#ifdef DEBUG
#define dbg(x) x
#else
#define dbg(x)
#endif

/* common.c */
/************/

extern char safegot;
extern char *localhostname,*localtaddr;
extern struct sockaddr_in localsaddr;
extern int cmdpar;
extern char *cmdpars[CMD_MAXPARS];
extern int *safesigs;

struct list {
	void *head,*tail;
	};
#define INIT_LIST(lt) (lt).head=NULL,(lt).tail=&(lt).head
#define LIST_EMPTY(lt) (!(lt).head)

#define destroy(str) do { free((str)); (str)=NULL; } while (0)

struct bufpart {
	struct bufpart *next;
	size_t done,len;
	char *buf;
	};
#define freebufpart(bp) do { free((bp)->buf); free((bp)); } while (0)

struct bufconn {
	int fd;
	struct list delwrite,delread;
	size_t delreadtot;
	unsigned writecnt;
	char *name;
	};

#define FDSETOPINT(fds,fdx) { \
	if (flg&FSO_SET) FD_SET(fd,&fds); \
	else if (flg&FSO_CLEAR) { FD_CLR(fd,&fds); FD_CLR(fd,&fdx); } \
	return(FD_ISSET(fd,&fdx)); \
	}

#define FDSETOP(fdrd,fdrdx,fdwr,fdwrx) \
static char fdsetop(int fd,unsigned flg) \
{ \
	assert(!(flg&~(FSO_SET|FSO_CLEAR|FSO_READ|FSO_WRITE))); \
	if ((flg&FSO_CLOSE)==FSO_CLOSE) { if (close(fd)) errout("&^close(fd %d)\n",fd); } \
	else if (flg&FSO_READ)  FDSETOPINT(fdrd,fdrdx) \
	else if (flg&FSO_WRITE) FDSETOPINT(fdwr,fdwrx) \
	return(0); \
}


extern void *remhead PARAMS((struct list *));
extern void addtail PARAMS((struct list *,void *node));
extern void remmid PARAMS((struct list *,void *node));
extern void writebuf PARAMS((struct bufconn *,const char *,size_t));
extern void chk PARAMS((const void *));
extern void errout PARAMS((const char *,...)) ATTR_PRINTFORMAT(1,2);
extern char saform_buf[SAFORM_BUF_SIZ];
extern const char *saform PARAMS((const struct sockaddr_in *));
extern const char *saformname PARAMS((const struct sockaddr_in *));
extern void trywrite PARAMS((struct bufconn *));
extern void rem_bp PARAMS((struct list *));
extern struct hostent *resolve PARAMS((const char *,struct sockaddr_in *));
extern void getlocalname PARAMS((void));
extern void linefuncize PARAMS((struct bufconn *conn,struct bufpart *bp,void (*func)(char *,struct bufconn *)));
extern void addfrag PARAMS((struct bufconn *conn,char *buf,size_t got,void (*func)(char *,struct bufconn *)));
extern void parsepars PARAMS((char *s));
extern void safeexit PARAMS((char doexit));

/* ggnboxcon.c */
/***************/
extern ggnboxfunc ggnboxcon;

/* ggnboxgtk.c */
/***************/
extern ggnboxfunc ggnboxgtk;

/* EXTERNAL */
extern void (*notifyggnp) PARAMS((ggnn_c,char **));
extern void (*presenterrp) PARAMS((char *));
extern void (*closeconnp) PARAMS((struct bufconn *));
extern char (*fdsetopp) PARAMS((int,unsigned));
#define FSO_CLEAR  (1<<0)
#define FSO_SET    (1<<1)
#define FSO_CLOSE  (FSO_CLEAR|FSO_SET)
#define FSO_READ   (1<<2)
#define FSO_WRITE  (1<<3)
#define FSO_EXCEPT (1<<4)

__END_DECLS

#endif /* _GGNPRIVATE_H */
