#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[] ATTR_UNUSED = "$Id: computer.c,v 1.1.1.1 1999/09/22 05:07:21 short Exp $";
#endif

#include "computer.h"
#include "game.h"
#include "network.h"
#include "ui.h"
#include "horde.h"
#include "library.h"

int computer_setup(Computer *C,int i) {
	int j, counter=0, flag;
	do {
		if (++counter>4000) return 0;
		C->x = game_RAND(computer_BORDER, game_scrwidth  - computer_BORDER - net.width);
		C->y = game_RAND(computer_BORDER, game_scrheight - computer_BORDER - net.height);
		flag=1;
		/*checks for conflicting computer placement*/
		for (j=0; j<i && flag; j++)
			if (game_INTERSECT(C->x, C->y,
				net.width-monster_XOFFSET+bill.width,
				net.height, net.computers[j].x,
				net.computers[j].y,
				net.width-monster_XOFFSET+bill.width,
				net.height))
					flag=0;
	} while (!flag);
	C->type = game_RAND(1, net_NUM_SYS);
	C->os = computer_determineOS(C);
	C->busy=0;
	return 1;
}

int computer_find_stray(Computer *C) {
	int i;
	for (i=0; i < bill_MAX_BILLS; i++) {
		if (bill.list[i].state != monster_STRAY) continue;
		if (game_INTERSECT(C->x, C->y, net.width, net.height, bill.list[i].x,
			bill.list[i].y, OS.width, OS.height))
				return i;
	}
	return -1;
}

int computer_oncomputer (Computer *C,int locx, int locy) {
	return (abs(locx-C->x) < net.width && abs(locy-C->y) < net.height);
}

int computer_compatible (Computer *C,int system) {
	return (C->type==system || (C->type>=OS_PC && system>=OS_PC));
}

int computer_determineOS(Computer *C) {
	if (C->type<OS_PC) return C->type;
	else return game_RAND (OS_PC, OS_NUM_OS);
}

void computer_draw(Computer *C) {
	ui_draw(&net.pictures[C->type], C->x, C->y);
	if (C->os != OS_OFF)
		ui_draw(&OS.os[C->os], C->x + computer_OFFSET, C->y + computer_OFFSET);
}
