#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[] ATTR_UNUSED = "$Id: data.c,v 1.1.1.1 1999/09/22 05:07:21 short Exp $";
#endif

#include <stdlib.h>
#include <assert.h>
#ifdef HAVE_LIBZ
#include <stdio.h>
#include <zlib.h>
#endif

#include "data.h"

#ifdef HAVE_LIBZ
const char *databall_start;
static z_stream strm;
#endif

void data_load(void)
{
#ifndef HAVE_LIBZ
	assert(databall_size==databall_bin_size);
#else
int r;
	assert(!databall_start);
	assert(databall_bin_start+databall_bin_size==databall_bin_end);
	if (!(databall_start=malloc(databall_size)))
		{ fprintf(stderr,"databall malloc(%d) ERROR!\n",databall_size); exit(1); }
	strm.  next_in=(Bytef *)databall_bin_start;
	strm. avail_in=databall_bin_size ;
	strm. next_out=(Bytef *)databall_start;
	strm.avail_out=databall_size ;
	if (inflateInit(&strm)!=Z_OK)
		{ fprintf(stderr,_("inflateInit failure: %s\n"),strm.msg); exit(1); }
	r=inflate(&strm,Z_FINISH);
	if ((r!=Z_OK && r!=Z_STREAM_END)
		||strm.  next_in!=(Bytef *)databall_bin_end
		||strm. avail_in!=0
		||strm. total_in!=databall_bin_size
		||strm. next_out!=(Bytef *)databall_start+databall_size
		||strm.avail_out!=0
		||strm.total_out!=databall_size
		) { fprintf(stderr,_("inflate ERROR!\n")); exit(1); }
	if (inflateEnd(&strm)!=Z_OK)
		{ fprintf(stderr,_("inflateEnd failure: %s\n"),strm.msg); exit(1); }
	assert( databall_start);
#endif
}

#ifdef HAVE_LIBZ
void data_finish(void)
{
	assert( databall_start);
	free((char *)databall_start); databall_start=NULL;
}
#endif
