#! /usr/bin/bash
# Used to generate header file databall.h for image references
#
# $Id: databallh.sh,v 1.2 2000/09/07 18:13:06 short Exp $

read XBMS
read XPMS
x="_binary_databall_bin_"
cat <<EOT
#ifndef DATABALL_H
#define DATABALL_H

/* File generated automatically, DON'T EDIT! */

#ifdef HAVE_BINARY_LINK
extern void ${x}start;
extern void ${x}end  ;
extern void ${x}size ;
#define databall_bin_start ((const char *)&${x}start)
#define databall_bin_end   ((const char *)&${x}end  )
#define databall_bin_size  ((size_t      )&${x}size )
#else /* HAVE_BINARY_LINK */
extern void ballgen_data_start;
extern const long ballgen_data_size;
#define databall_bin_start ((const char *)&ballgen_data_start)
#define databall_bin_size  ((size_t      )ballgen_data_size )
#define databall_bin_end   ((const char *)(databall_bin_start+databall_bin_size))
#endif /* HAVE_BINARY_LINK */

/* Bitmaps: */

EOT
offs=0
for i in $XBMS;do
  n="`basename "$i" .xbm`_xbm"
  head -n 2 "$i"|sed "s/ \([^ ]*\)_/ ${n}_/"
  size=`(tr -cd , <"$i";echo)|wc -c`
  if [ $size -le 0 ];then echo "SANITY: $i size = 0" >&2;exit 1;fi
  echo "#define ${n}_offset $offs"
  echo "#define ${n}_size $size"
  offs=`echo $offs+$size|bc`
  echo;done
cat <<EOT
/* Pixmaps: */

EOT
for i in $XPMS;do
  n="`basename "$i" .xpm`_xpm"
  lines=`wc -l <"$i"`
  lines=`echo $lines-2|bc`
  echo "#define ${n}_lines $lines"
  size=`tail +3 "$i"|sed -n 's/^"\(.*\)"[,}];* *$/\1/p'|wc -c`
  if [ $size -le 0 ];then echo "SANITY: $i size = 0" >&2;exit 1;fi
  echo "#define ${n}_offset $offs"
  echo "#define ${n}_size $size"
  offs=`echo $offs+$size|bc`
  echo;done
cat <<EOT
#define databall_size $offs

#endif
EOT

if false;then

if [ -n "$1" ];then
  if [ -n "$2" ];then s=`zcat "$1"|wc -c`
  else s=`find -name "$1" -printf "%s"`
  fi
  if [ $s != $offs ];then echo "SANITY: $s != $offs" >&2;exit 1;fi
  fi

fi

exit 0
