#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[] ATTR_UNUSED = "$Id: datagen.c,v 1.1.1.1 1999/09/22 05:07:21 short Exp $";
#endif

#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_ZLIB_H
#include <zlib.h>
#endif

#ifdef HAVE_LIBZ
#define ZBUF_SIZE 256*1024
#endif

struct xbm_list { unsigned char  *data; size_t len; };
struct xpm_list {          char **data; size_t len; };
#define NSIZE(x) (sizeof((x))/sizeof(*(x)))

#include "datagen.h"

#ifdef HAVE_LIBZ
char ubuf[ZBUF_SIZE],zbuf[ZBUF_SIZE];
size_t ubufd;
z_stream strm;
#define OUTPUT(buf,len) zout((const char *)(buf),(len));

static void zout(const char *buf,size_t len)
{
	if (ubufd+len>=sizeof(ubuf)) {
		fprintf(stderr,"UBUF size %d insufficient!\n",sizeof(ubuf));
		exit(EXIT_FAILURE);
		}
	memcpy(ubuf+ubufd,buf,len);
	ubufd+=len;
}
#else
#define OUTPUT(buf,len) fwrite((buf),(len),1,stdout)
#endif

int main(void)
{
int i,j;
size_t offs=0,len;

	for (i=0;i<NSIZE(xbm_list);i++) {
		len=xbm_list[i].len;
		fprintf(stderr,"XBM%02d: @%6d+%5d\n",i,offs,len); offs+=len;
		OUTPUT(xbm_list[i].data,len);
		}
	for (i=0;i<NSIZE(xpm_list);i++) {
		len=0;
		for (j=0;j<xpm_list[i].len;j++) {
size_t llen;
			llen=strlen(xpm_list[i].data[j])+1; len+=llen;
			OUTPUT(xpm_list[i].data[j],llen);
			}
		fprintf(stderr,"XPM%02d: @%6d+%5d\n",i,offs,len); offs+=len;
		}
#ifdef HAVE_LIBZ
	strm.  next_in=(Bytef *)ubuf;
	strm. avail_in=ubufd;
	strm. next_out=(Bytef *)zbuf;
	strm.avail_out=sizeof(zbuf);
	if (deflateInit(&strm,Z_BEST_COMPRESSION)!=Z_OK)
		{ fprintf(stderr,"deflateInit ERROR: %s\n",strm.msg); exit(EXIT_FAILURE); }
	if (deflate(&strm,Z_FINISH)!=Z_STREAM_END)
		{ fprintf(stderr,"deflate ERROR: %s\n",strm.msg); exit(EXIT_FAILURE); }
	if (0
		||strm.  next_in!=(Bytef *)ubuf+ubufd
		||strm. avail_in!=0
		||strm.next_out+strm.avail_out!=(Bytef *)zbuf+sizeof(zbuf)
		) { fprintf(stderr,"deflate data ERROR!\n"); exit(EXIT_FAILURE); }
	if (deflateEnd(&strm)!=Z_OK)
		{ fprintf(stderr,"deflateEnd ERROR: %s\n",strm.msg); exit(EXIT_FAILURE); }
	fwrite(zbuf,sizeof(zbuf)-strm.avail_out,1,stdout);
#endif

	fflush(stdout);
	fprintf(stderr,"TOTAL:  %6d\n",offs);
	return(0);
}
