#ifndef GAME_H
#define GAME_H

/*
 * $Id: game.h,v 1.1.1.1 1999/09/22 05:07:21 short Exp $
 */

#include "config.h"

#include "picture.h"

#ifdef DEBUG
#define dbg(x) x
#else
#define dbg(x)
#endif

#define d(x) dbg(printf x)

typedef struct {
	int state;
	int efficiency;
	unsigned score, iteration;
	int level;
	Picture logo,bang;
	int grabbed;
	char *version;

#define game_scrwidth 400
#define game_scrheight 400

#define game_PLAYING 1
#define game_BETWEEN 2
#define game_END 3
#define game_WAITING 4

#define game_DEFAULTC 0		/* cursors */
#define game_DOWNC -1
#define game_BUCKETC -2

#define game_ENDGAME 200		/* dialog window IDs */
#define game_ENTERNAME 201
#define game_HIGHSCORE 202
#define game_SCORE 203

#define game_ENDLEVEL -1		/* Codes for updating score */
#define game_BILLPOINTS 5

#define game_EMPTY -2		/* Grabbed object */
#define game_BUCKET -1

} Game;
extern Game game;

extern struct poptOption game_popts[];

int game_RAND PARAMS((int lb, int ub));
int game_INTERSECT PARAMS((int x1, int y1, int w1, int h1, int x2, int y2, int w2, int h2));
void game_setup_level  PARAMS((char restart,unsigned int lev));
void game_start PARAMS((unsigned int lev));
void game_quit PARAMS((void));
void game_clear PARAMS((void));
void game_update_info PARAMS((void));
void game_update_score  PARAMS((int action));
void game_warp_to_level  PARAMS((int lev));
void game_button_press PARAMS((int x, int y,char *text));
void game_button_release PARAMS((int x, int y,char *text));
void game_update PARAMS((char fromnet));
/* __NORETURN */ void game_usage PARAMS((void));

#endif
