#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[] ATTR_UNUSED = "$Id: gtk10.c,v 1.2 1999/10/10 08:48:17 short Exp $";
#endif

#include "gtk10.h"

#include <string.h>
#include <assert.h>

#ifndef HAVE_GTK_ITEM_FACTORY_CREATE_ITEMS

GtkMenuFactory *menufactory10;

GtkWidget *gtk10_item_factory_create_items(guint n_entries,GtkItemFactoryEntry *entries,const gchar *path,GtkWidget *win)
{
GtkMenuEntry *menu10;
gint ep,dp;
GtkMenuFactory *factory;
GtkMenuFactory *subfactory;

	assert(!menufactory10);
	if (!(menu10=alloca(sizeof(*menu10)*n_entries))) return(NULL);
	for (ep=dp=0;ep<n_entries;ep++) {
GtkMenuEntry *d=menu10+dp;
GtkItemFactoryEntry *e=entries+ep;
char *s,*q;
		if (e->item_type) continue;
		if (!(d->path=alloca(strlen(path)+strlen(e->path)+1))) return(NULL);
		strcpy(d->path,path);
		strcat(d->path,e->path);
		for (s=q=d->path;*s;s++) if (*s!='_') *q++=*s;
		*q='\0';
		d->accelerator=e->accelerator;
		d->callback=(GtkMenuCallback)e->callback;
		d->callback_data=(gpointer)e->callback_action;
		d->widget=NULL;
		dp++;
		}

	factory=gtk_menu_factory_new(GTK_MENU_FACTORY_MENU_BAR);
	subfactory=gtk_menu_factory_new(GTK_MENU_FACTORY_MENU_BAR);

	gtk_menu_factory_add_subfactory(factory,subfactory,path);
	gtk_menu_factory_add_entries(factory,menu10,dp);
	gtk_window_add_accelerator_table(GTK_WINDOW(win),subfactory->table);

	menufactory10=factory;
	return(subfactory->widget);
}

#endif /* !HAVE_GTK_ITEM_FACTORY_CREATE_ITEMS */

#ifndef HAVE_GTK_WINDOW_SET_MODAL

void gtk_window_set_modal(GtkWindow *window,gboolean modal)
{
	assert(modal);
	gtk_signal_connect_object(GTK_OBJECT(window),"show",GTK_SIGNAL_FUNC(gtk_grab_add   ),GTK_OBJECT(window));
	gtk_signal_connect_object(GTK_OBJECT(window),"hide",GTK_SIGNAL_FUNC(gtk_grab_remove),GTK_OBJECT(window));
}

#endif /* !HAVE_GTK_WINDOW_SET_MODAL */
