#ifndef GTK10_H
#define GTK10_H

/*
 * $Id: gtk10.h,v 1.2 1999/10/10 08:48:17 short Exp $
 */

#include "config.h"

#include <gtk/gtk.h>

#ifndef HAVE_GTK_ITEM_FACTORY_CREATE_ITEMS
typedef void    (*GtkItemFactoryCallback)  ();
typedef struct  _GtkItemFactoryEntry            GtkItemFactoryEntry;

struct _GtkItemFactoryEntry
{
  gchar *path;
  gchar *accelerator;

  GtkItemFactoryCallback callback;
  guint                  callback_action;

  /* possible values:
   * NULL               -> "<Item>"
   * ""                 -> "<Item>"
   * "<Title>"          -> create a title item
   * "<Item>"           -> create a simple item
   * "<CheckItem>"      -> create a check item
   * "<ToggleItem>"     -> create a toggle item
   * "<RadioItem>"      -> create a radio item
   * <path>             -> path of a radio item to link against
   * "<Separator>"      -> create a separator
   * "<Branch>"         -> create an item to hold sub items
   * "<LastBranch>"     -> create a right justified item to hold sub items
   */
  gchar          *item_type;
};

extern GtkMenuFactory *menufactory10;
extern GtkWidget *gtk10_item_factory_create_items PARAMS((guint n_entries,GtkItemFactoryEntry *entries,const gchar *path,GtkWidget *win));
#endif /* !HAVE_GTK_ITEM_FACTORY_CREATE_ITEMS */

#ifndef HAVE_GTK_WINDOW_SET_MODAL
extern void gtk_window_set_modal PARAMS((GtkWindow *window,gboolean modal));
#endif /* !HAVE_GTK_WINDOW_SET_MODAL */

#endif
