#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[] ATTR_UNUSED = "$Id: horde.c,v 1.1.1.1 1999/09/22 05:07:21 short Exp $";
#endif

#include <glib.h>

#include "horde.h"
#include "game.h"
#include "picture.h"

Horde bill;

void bill_setup(void) {
int i;
	for (i=0; i < bill_MAX_BILLS; i++)
		bill.list[i].state = monster_OFF;
	bill.off_screen = bill_on (game.level);
	bill.on_screen = 0;
}

/*  Launches Bills whenever called  */
void bill_launch(int max){
	int i, n;
	if (!max || !bill.off_screen) return;
	n=game_RAND(1, MIN(max, bill.off_screen));
	for (i=0; n; n--) {
		for (i++; i < bill_MAX_BILLS; i++)
			if (bill.list[i].state == monster_OFF) break;
		if (i == bill_MAX_BILLS) return;
		monster_enter(&bill.list[i++]);
	}
}

int bill_on (int lev) {
	return MIN(8+3*lev, bill_MAX_BILLS);
}

int bill_max_at_once (int lev) {
	return MIN(2+lev/4, 12);
}

int bill_between (int lev) {
	return MAX(14-lev/3, 10);
}

void bill_load_pix(void) {
#define IDXLOAD(arr,name,n) PICTURE_LOAD(bill.arr[n],name##_##n)

IDXLOAD(lcels,billL, 0);
IDXLOAD(rcels,billR, 0);
IDXLOAD(lcels,billL, 1);
IDXLOAD(rcels,billR, 1);
IDXLOAD(lcels,billL, 2);
IDXLOAD(rcels,billR, 2);

	bill.lcels[bill_WCELS-1] = bill.lcels[1]; 
	bill.rcels[bill_WCELS-1] = bill.rcels[1]; 

IDXLOAD(dcels,billD, 0);
IDXLOAD(dcels,billD, 1);
IDXLOAD(dcels,billD, 2);
IDXLOAD(dcels,billD, 3);
IDXLOAD(dcels,billD, 4);

	bill.width =bill.dcels[0].width ;
	bill.height=bill.dcels[0].height;

IDXLOAD(acels,billA, 0);
IDXLOAD(acels,billA, 1);
IDXLOAD(acels,billA, 2);
IDXLOAD(acels,billA, 3);
IDXLOAD(acels,billA, 4);
IDXLOAD(acels,billA, 5);
IDXLOAD(acels,billA, 6);
IDXLOAD(acels,billA, 7);
IDXLOAD(acels,billA, 8);
IDXLOAD(acels,billA, 9);
IDXLOAD(acels,billA,10);
IDXLOAD(acels,billA,11);
IDXLOAD(acels,billA,12);

#undef IDXLOAD
}

void bill_update(void) {
	int i;
	if (!(game.iteration % bill_between(game.level)))
		bill_launch(bill_max_at_once(game.level));
	for (i=0; i < bill_MAX_BILLS; i++) monster_update(&bill.list[i]);
}

void bill_draw(void) {
	int i;
	for (i=0; i < bill_MAX_BILLS; i++) monster_draw(&bill.list[i]);
}
