#ifndef HORDE_H
#define HORDE_H

/*
 * $Id: horde.h,v 1.1.1.1 1999/09/22 05:07:21 short Exp $
 */

#include "config.h"

#include "monster.h"
#include "picture.h"

typedef struct {			/*global structure of all bills*/

#define bill_MAX_BILLS 100	/*max Bills per level*/
#define bill_WCELS 4	/* # of bill walking animation frames*/
#define bill_DCELS 5	/* # of bill dying animation frames*/
#define bill_ACELS 13	/* # of bill switching OS frames*/

	Monster list[bill_MAX_BILLS];	/* list of monsters in all states*/
	int width, height;
	int on_screen, off_screen;
	Picture lcels[bill_WCELS], rcels[bill_WCELS], acels[bill_ACELS], dcels[bill_DCELS];
} Horde;
extern Horde bill;

void bill_load_pix PARAMS((void));
void bill_setup PARAMS((void));
void bill_launch PARAMS((int max));
int bill_on PARAMS((int lev));
int bill_max_at_once PARAMS((int lev));
int bill_between PARAMS((int lev));
void bill_update PARAMS((void));
void bill_draw PARAMS((void));

#endif
