#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[] ATTR_UNUSED = "$Id: mcursor.c,v 1.1.1.1 1999/09/22 05:07:21 short Exp $";
#endif

#include <gdk/gdk.h>
#include <assert.h>
#include <stdlib.h>

#include "mcursor.h"
#include "data.h"
#include "ui.h"

static MCursor *tracker[20];
static int tracki=0;

void mcursor_load1(MCursor *M,size_t offs,gint width,gint height)
{
	assert(tracki<NSIZE(tracker));
	tracker[tracki++]=M;
	assert(!M->data && !M->cursor);
	M->data=(const unsigned char *)databall_start+offs;
	M->width=width; M->height=height;
}

void mcursor_load2(MCursor *M,size_t offs,size_t maskoffs,gint width,gint height)
{
	mcursor_load1(M,offs,width,height);
	M->mask=(const unsigned char *)databall_start+maskoffs;
}

static void cursorize(MCursor *M)
{
GdkBitmap *bitmap,*bitmapmask;
GtkStyle *style;

	if (M->cursor) return;
	assert(M->data);
	bitmap=gdk_bitmap_create_from_data(ui.drawarea->window,(gchar *)M->data,M->width,M->height);
	bitmapmask=(!M->mask?bitmap:gdk_bitmap_create_from_data(ui.drawarea->window,
		(char *)M->mask,M->width,M->height));
	style=gtk_widget_get_style(ui.drawarea);
	M->cursor=gdk_cursor_new_from_pixmap(
	/* HACK Alert! GdkPixmap!=GdkBitmap but obviously currently (GTK1.1.8) it is so. */
		(GdkPixmap *)bitmap,(GdkPixmap *)bitmapmask,
		&style->black,&style->white,M->width/2,M->height/2);
	gdk_bitmap_unref(bitmap);
	if (bitmapmask!=bitmap) gdk_bitmap_unref(bitmapmask);
	M->data=M->mask=NULL;
	assert(M->cursor);
}

void mcursor_set(MCursor *M)
{
	if (!ui.drawarea || !ui.drawarea->window) return;
	cursorize(M);
	gdk_window_set_cursor(ui.drawarea->window,M->cursor);
}

void mcursor_finish(void)
{
int ti;
	assert (ui.drawarea && ui.drawarea->window);
	for (ti=0;ti<tracki;ti++) cursorize(tracker[ti]);
	tracki=0;
}
