#ifndef BILL_H
#define BILL_H

/*
 * $Id: monster.h,v 1.1.1.1 1999/09/22 05:07:21 short Exp $
 */

#include "config.h"

#include "picture.h"

typedef struct {		/*structure for Bills*/
	int state;		/*what is it doing?*/
	int index;		/*index to animation frame*/
	Picture *cels;		/*pointer to array of animation frames*/
	int x, y;		/*location*/
	int target_x;		/*target x position*/
	int target_y;		/*target y position*/
	int target_c;		/*target computer*/
	int cargo;		/*which OS carried*/
	int x_offset;		/*accounts for width differences*/
	int y_offset;		/*'bounce' factor for OS carried*/
	int sx, sy;		/*used for drawing extra OS during switch*/
	char *killer;

#define monster_SLOW 0	/* speeds of moving bills */
#define monster_FAST 1

#define monster_OFF 0	/* Bill's states */
#define monster_IN 1
#define monster_AT 2
#define monster_OUT 3
#define monster_DYING 4
#define monster_STRAY 5

#define monster_GRAVITY 3	/*speed at which os drops*/

#define monster_XOFFSET 20	/*offset from right of computer*/
#define monster_YOFFSET 3	/*offset from top of computer*/

} Monster;

void monster_get_border PARAMS((Monster *M));
void monster_enter PARAMS((Monster *M));
int monster_move PARAMS((Monster *M,int mode));
void monster_draw PARAMS((Monster *M));
void monster_draw_std PARAMS((Monster *M));
void monster_draw_at PARAMS((Monster *M));
void monster_draw_stray PARAMS((Monster *M));
void monster_update PARAMS((Monster *M));
void monster_update_in PARAMS((Monster *M));
void monster_update_at PARAMS((Monster *M));
void monster_update_out PARAMS((Monster *M));
void monster_update_dying PARAMS((Monster *M));
int monster_clicked PARAMS((Monster *M,int locx, int locy));
int monster_clickedstray PARAMS((Monster *M,int locx, int locy));
int monster_step_size PARAMS((unsigned int lev));

#endif
