#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[] ATTR_UNUSED = "$Id: network.c,v 1.1.1.1 1999/09/22 05:07:21 short Exp $";
#endif

#include <glib.h>

#include "network.h"
#include "game.h"
#include "library.h"
#include "picture.h"

Network net;

/*sets up network for each level*/
void net_setup(void) {
	int i;	
	net.units = net_on (game.level);
	for (i=0; i<net.units; i++)
		if (!computer_setup(&net.computers[i],i)) {
			net.units = i-1;
			break;
		}
	net.base = net.units;
	net.off = net.win = 0;
	net.ncables = MIN(game.level, net.units/2);
	for (i=0; i<net.ncables; i++) cable_setup(&net.cables[i]);
}

/*redraws the computers at their location with the proper image*/
void net_draw (void) {
	int i;
	for (i=0; i<net.ncables; i++) cable_draw(&net.cables[i]);
	for (i=0; i<net.units; i++) computer_draw(&net.computers[i]);
}

void net_update (void) {
int i;
	for (i=0; i<net.ncables; i++) cable_update(&net.cables[i]);
}

void net_toasters (void) {
int i;
	for (i=0; i<net.units; i++) {
		net.computers[i].type = computer_TOASTER;
		net.computers[i].os = OS_OFF;
	}
	net.ncables=0;
}

int net_on(int lev) {
	return MIN(8+lev, net_MAX_COMPUTERS);
}

void net_load_pix (void) {
#define IDXLOAD(name,n) PICTURE_LOAD(net.pictures[n],name)

IDXLOAD(toaster,0);
IDXLOAD(maccpu ,1);
IDXLOAD(nextcpu,2);
IDXLOAD(sgicpu ,3);
IDXLOAD(suncpu ,4);
IDXLOAD(os2cpu ,5);
IDXLOAD(bsdcpu ,6);

#undef IDXLOAD
	net.width =net.pictures[0].width ;
	net.height=net.pictures[0].height;
}
