#ifndef NETWORK_H
#define NETWORK_H

/*
 * $Id: network.h,v 1.1.1.1 1999/09/22 05:07:21 short Exp $
 */

#include "config.h"

#include "picture.h"
#include "computer.h"
#include "cable.h"

typedef struct {	/*structure for global network of computers*/

#define net_MAX_COMPUTERS 20	/* max computers on screen */
#define net_NUM_SYS 6		/* number of computer types */

	Picture pictures[net_NUM_SYS+1];	/* array of cpu pictures */
	int width, height;			/* size of cpu picture */
	int units;				/* number of cpus in network */
	int win, base, off;			/* number in each state */
	Computer computers[net_MAX_COMPUTERS];	/* array of cpu info */
	Cable cables[net_MAX_COMPUTERS];
	int ncables;

} Network;
extern Network net;

void net_setup PARAMS((void));
void net_load_pix PARAMS((void));
void net_draw PARAMS((void));
void net_update PARAMS((void));
void net_toasters PARAMS((void));
int net_on PARAMS((int lev));

#endif
