#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[] ATTR_UNUSED = "$Id: picture.c,v 1.1.1.1 1999/09/22 05:07:21 short Exp $";
#endif

#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

#include "picture.h"
#include "data.h"
#include "ui.h"

void picture_load(Picture *P,size_t offs,unsigned lines)
{
const char **cpp,**cpd;
const char *cs;

	assert(!P->pixmap); assert(ui.mainwin); assert(ui.mainwin->window); assert(ui.mainwinstyle);

	if (!(cpp=alloca(sizeof(*cpp)*lines)))
		{ fprintf(stderr,_("Out of memory!\n")); exit(1); }
	cs=databall_start+offs;
	cpd=cpp;
	while (lines--) {
		*cpd++=cs;
		cs+=strlen(cs)+1;
		}

	P->pixmap=gdk_pixmap_create_from_xpm_d(ui.mainwin->window,&P->mask,
		&ui.mainwinstyle->white,
		(gchar **)cpp);
	gdk_window_get_size(P->pixmap,&P->width,&P->height);
	assert(P->pixmap && P->width && P->height);
	P->gc=gdk_gc_new(P->pixmap);
	gdk_gc_set_clip_mask(P->gc,P->mask);
}

GtkWidget *picture_gtk_pixmap(Picture *P)
{
	assert(P->pixmap);
	return gtk_pixmap_new(P->pixmap,P->mask);
}
