#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[] ATTR_UNUSED = "$Id: scorelist.c,v 1.1.1.1 1999/09/22 05:07:21 short Exp $";
#endif

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#ifdef HAVE_GNOME
#include <gnome.h>
#endif

#include "scorelist.h"
#include "ui.h"
#include "game.h"

Scorelist scores;

#ifndef HAVE_GNOME
#ifdef XBILL_SCOREFILE
FILE *scores_open_file(char *mode) {
	char file[255],*home=getenv("HOME");
	if (!home) home="/tmp";
	sprintf (file,XBILL_SCOREFILE,home);
	return fopen(file,mode);
}
#endif /* XBILL_SCOREFILE */
#endif /* HAVE_GNOME */

void scores_read(void) {
	int i;

#ifdef HAVE_GNOME
	gnome_config_push_prefix(PACKAGE "/Scores/");
		for (i=0; i<10; i++) {
char num[10],*buf,*s;
int consumed;

			VARPRINTF(num,"%d",i);
			buf=gnome_config_get_string_with_default(num,NULL);
			if (!buf || sscanf(buf,"%u%u%n",scores.level+i,scores.score+i,&consumed)<2) {
				if (buf) g_free(buf);
				strcpy(scores.name[i], _("me"));
				scores.level[i] = scores.score[i] = 0;
				continue;
				}
			for (s=buf+consumed;isspace(*s);s++);
			strncpy(scores.name[i],s,sizeof(scores.name[0]));
			scores.name[i][sizeof(scores.name[0])-1]='\0';
			}
	gnome_config_pop_prefix();
#else
#ifdef XBILL_SCOREFILE
	FILE *scorefile = scores_open_file("r");
	if (scorefile) {
		for (i=0; i<10; i++) {
			fgets (scores.name[i], 21, scorefile);
			fscanf (scorefile, "%d%d\n", &(scores.level[i]), &(scores.score[i]));
		}
		fclose(scorefile);
	}
	else
#endif /* XBILL_SCOREFILE */
		for (i=0; i<10; i++) {
			strcpy(scores.name[i], _("me"));
			scores.level[i] = scores.score[i] = 0;
		}
#endif /* HAVE_GNOME */
}

void scores_write(void) {
#ifdef HAVE_GNOME
	int i;
	gnome_config_push_prefix(PACKAGE "/Scores/");
		for (i=0; i<10; i++) {
char num[10],buf[100];
			VARPRINTF(num,"%d",i);
			VARPRINTF3(buf,"%u %u %s",scores.level[i],scores.score[i],scores.name[i]);
			gnome_config_set_string(num,buf);
			}
	gnome_config_pop_prefix();
	gnome_config_sync();
#else
#ifdef XBILL_SCOREFILE
	int i, j;
	FILE *scorefile = scores_open_file("w");
	if (!scorefile) return;
	for (i=0; i<10; i++) {
		fputs(scores.name[i], scorefile);
		for (j=strlen(scores.name[i]); j<25; j++)
			fputc(' ', scorefile);
		fprintf (scorefile, " %d %d\n", scores.level[i], scores.score[i]);
	}
	fclose(scorefile);
#endif /* XBILL_SCOREFILE */
#endif /* HAVE_GNOME */
}

/*  Add new high score to list   */
void scores_recalc (char *str) {
	int i;
	if (scores.score[9] >= game.score) return;
	for (i=9; i>0; i--) {
		if (scores.score[i-1] < game.score) {
			strcpy (scores.name[i], scores.name[i-1]);
			scores.level[i] = scores.level[i-1];
			scores.score[i] = scores.score[i-1];
		}
		else break;
	}
	strcpy (scores.name[i], str);
	scores.level[i] = game.level;
	scores.score[i] = game.score;
}

void scores_update() { ui_update_hsbox(); }
