#ifndef UI_H
#define UI_H

/*
 * $Id: ui.h,v 1.2 1999/10/10 08:48:17 short Exp $
 */

#include "config.h"

#include <gtk/gtk.h>

#include "gtk10.h"
#include "picture.h"
#include "mcursor.h"

#define NSIZE(x) (sizeof((x))/sizeof(*(x)))

#define MAX_LEVEL 100
#define MAX_LEVEL_STEP 10

typedef struct {
	int playing;
	Picture icon;
	MCursor defaultcursor, downcursor;
	GtkWidget *statusbar;
#ifdef HAVE_GTK_ITEM_FACTORY_CREATE_ITEMS
	GtkItemFactory *mainwinfactory;
#endif
	char istimer; gint timer;
	GdkGC *linegc,*whitegc,*yellowgc,*redgc;
	GtkWidget *lastCPBtext;
	GtkWidget *mainwin,*drawarea;
	GtkWidget *levelwin,*levelentry;
	GtkWidget *enternamebox,*enternameentry;
	GtkWidget *scorebox,*scoretext;
	GtkWidget *endgamebox;
	GtkWidget *highscorebox,*highscorelist;
	GtkWidget *aboutbox,*rulesbox,*storybox,*pausebox;
	GtkStyle *mainwinstyle;
	GdkPixmap *offscreen;
} UI;
extern UI ui;

void ui_restart_timer PARAMS((void));
void ui_kill_timer PARAMS((void));
void ui_pause_game PARAMS((void));
void ui_resume_game PARAMS((void));
void ui_initialize PARAMS((int *argc, char ***argv));
void ui_make_windows PARAMS((void));
void ui_popup_dialog PARAMS((int dialog));
void ui_set_cursor PARAMS((int cursor));
void ui_load_cursors PARAMS((void));
void ui_clear PARAMS((void));
void ui_refresh PARAMS((void));
void ui_draw PARAMS((Picture *picture, int x, int y));
void ui_draw_string PARAMS((const char *string,int x,int y,GdkGC *gc));
void ui_draw_centered PARAMS((Picture *picture));
void ui_draw_line PARAMS((int x1, int y1, int x2, int y2));
void ui_set_statusbar PARAMS((const char *str));
void ui_set_pausebutton PARAMS((int action));
void ui_set_ggndisconnbutton PARAMS((int action));
void ui_MainLoop PARAMS((void));
void ui_update_scorebox PARAMS((int level, int score));
void ui_update_hsbox PARAMS((void));

#endif
